// <auto-generated />
namespace IronJS.Tests.UnitTests.Sputnik.Conformance.Expressions.BinaryLogicalOperators
{
    using System;
    using NUnit.Framework;

    [TestFixture]
    public class LogicalOROperatorTests : SputnikTestFixture
    {
        public LogicalOROperatorTests()
            : base(@"Conformance\11_Expressions\11.11_Binary_Logical_Operators\11.11.2_Logical_OR_Operator")
        {
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.11.2")]
        [TestCase("S11.11.2_A1.js", Description = "White Space and Line Terminator between LogicalORExpression and \"||\" or between \"||\" and LogicalANDExpression are allowed")]
        public void WhiteSpaceAndLineTerminatorBetweenLogicalORExpressionAndOrBetweenAndLogicalANDExpressionAreAllowed(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.11.2")]
        [Category("ECMA 16")]
        [Category("ECMA 8.7.1")]
        [TestCase("S11.11.2_A2.1_T1.js", Description = "Operator x || y uses GetValue")]
        [TestCase("S11.11.2_A2.1_T2.js", Description = "Operator x || y uses GetValue")]
        [TestCase("S11.11.2_A2.1_T3.js", Description = "Operator x || y uses GetValue")]
        [TestCase("S11.11.2_A2.1_T4.js", Description = "Operator x || y uses GetValue")]
        public void OperatorXYUsesGetValue(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.11.2")]
        [TestCase("S11.11.2_A2.4_T1.js", Description = "First expression is evaluated first, and then second expression")]
        [TestCase("S11.11.2_A2.4_T2.js", Description = "First expression is evaluated first, and then second expression")]
        [TestCase("S11.11.2_A2.4_T3.js", Description = "First expression is evaluated first, and then second expression")]
        public void FirstExpressionIsEvaluatedFirstAndThenSecondExpression(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.11.2")]
        [TestCase("S11.11.2_A3_T1.js", Description = "If ToBoolean(x) is false, return y")]
        [TestCase("S11.11.2_A3_T2.js", Description = "If ToBoolean(x) is false, return y")]
        [TestCase("S11.11.2_A3_T3.js", Description = "If ToBoolean(x) is false, return y")]
        [TestCase("S11.11.2_A3_T4.js", Description = "If ToBoolean(x) is false, return y")]
        public void IfToBooleanXIsFalseReturnY(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.11.2")]
        [TestCase("S11.11.2_A4_T1.js", Description = "If ToBoolean(x) is true, return x")]
        [TestCase("S11.11.2_A4_T2.js", Description = "If ToBoolean(x) is true, return x")]
        [TestCase("S11.11.2_A4_T3.js", Description = "If ToBoolean(x) is true, return x")]
        [TestCase("S11.11.2_A4_T4.js", Description = "If ToBoolean(x) is true, return x")]
        public void IfToBooleanXIsTrueReturnX(string file)
        {
            RunFile(file);
        }
    }
}