// <auto-generated />
namespace IronJS.Tests.UnitTests.Sputnik.Conformance.Expressions.RelationalOperators
{
    using System;
    using NUnit.Framework;

    [TestFixture]
    public class TheGreaterThanOperatorTests : SputnikTestFixture
    {
        public TheGreaterThanOperatorTests()
            : base(@"Conformance\11_Expressions\11.8_Relational_Operators\11.8.2_The_Greater_than_Operator")
        {
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.8.2")]
        [Category("ECMA 7.2")]
        [Category("ECMA 7.3")]
        [TestCase("S11.8.2_A1.js", Description = "White Space and Line Terminator between RelationalExpression and \">\" or \">\" and ShiftExpression are allowed")]
        public void WhiteSpaceAndLineTerminatorBetweenRelationalExpressionAndOrAndShiftExpressionAreAllowed(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.8.2")]
        [Category("ECMA 11.8.5")]
        [TestCase("S11.8.2_A2.1_T1.js", Description = "Operator x > y uses GetValue")]
        [TestCase("S11.8.2_A2.1_T2.js", Description = "Operator x > y uses GetValue")]
        [TestCase("S11.8.2_A2.1_T3.js", Description = "Operator x > y uses GetValue")]
        public void OperatorXYUsesGetValue(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.8.2")]
        [Category("ECMA 8.6.2.6")]
        [TestCase("S11.8.2_A2.2_T1.js", Description = "Operator x > y uses [[Default Value]]")]
        public void OperatorXYUsesDefaultValue(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.8.2")]
        [TestCase("S11.8.2_A2.3_T1.js", Description = "ToNumber(second expression) is called first, and then ToNumber(first expression)")]
        public void ToNumberSecondExpressionIsCalledFirstAndThenToNumberFirstExpression(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.8.2")]
        [TestCase("S11.8.2_A2.4_T1.js", Description = "First expression is evaluated first, and then second expression")]
        [TestCase("S11.8.2_A2.4_T2.js", Description = "First expression is evaluated first, and then second expression")]
        [TestCase("S11.8.2_A2.4_T3.js", Description = "First expression is evaluated first, and then second expression")]
        public void FirstExpressionIsEvaluatedFirstAndThenSecondExpression(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.8.2")]
        [TestCase("S11.8.2_A3.1_T1.1.js", Description = "If Type(Primitive(x)) is not String or Type(Primitive(y)) is not String, then operator x > y returns ToNumber(x) > ToNumber(y)")]
        [TestCase("S11.8.2_A3.1_T1.2.js", Description = "If Type(Primitive(x)) is not String or Type(Primitive(y)) is not String, then operator x > y returns ToNumber(x) > ToNumber(y)")]
        [TestCase("S11.8.2_A3.1_T1.3.js", Description = "If Type(Primitive(x)) is not String or Type(Primitive(y)) is not String, then operator x > y returns ToNumber(x) > ToNumber(y)")]
        [TestCase("S11.8.2_A3.1_T2.1.js", Description = "If Type(Primitive(x)) is not String or Type(Primitive(y)) is not String, then operator x > y returns ToNumber(x) > ToNumber(y)")]
        [TestCase("S11.8.2_A3.1_T2.2.js", Description = "If Type(Primitive(x)) is not String or Type(Primitive(y)) is not String, then operator x > y returns ToNumber(x) > ToNumber(y)")]
        [TestCase("S11.8.2_A3.1_T2.3.js", Description = "If Type(Primitive(x)) is not String or Type(Primitive(y)) is not String, then operator x > y returns ToNumber(x) > ToNumber(y)")]
        [TestCase("S11.8.2_A3.1_T2.4.js", Description = "If Type(Primitive(x)) is not String or Type(Primitive(y)) is not String, then operator x > y returns ToNumber(x) > ToNumber(y)")]
        [TestCase("S11.8.2_A3.1_T2.5.js", Description = "If Type(Primitive(x)) is not String or Type(Primitive(y)) is not String, then operator x > y returns ToNumber(x) > ToNumber(y)")]
        [TestCase("S11.8.2_A3.1_T2.6.js", Description = "If Type(Primitive(x)) is not String or Type(Primitive(y)) is not String, then operator x > y returns ToNumber(x) > ToNumber(y)")]
        [TestCase("S11.8.2_A3.1_T2.7.js", Description = "If Type(Primitive(x)) is not String or Type(Primitive(y)) is not String, then operator x > y returns ToNumber(x) > ToNumber(y)")]
        [TestCase("S11.8.2_A3.1_T2.8.js", Description = "If Type(Primitive(x)) is not String or Type(Primitive(y)) is not String, then operator x > y returns ToNumber(x) > ToNumber(y)")]
        [TestCase("S11.8.2_A3.1_T2.9.js", Description = "If Type(Primitive(x)) is not String or Type(Primitive(y)) is not String, then operator x > y returns ToNumber(x) > ToNumber(y)")]
        public void IfTypePrimitiveXIsNotStringOrTypePrimitiveYIsNotStringThenOperatorXYReturnsToNumberXToNumberY(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.8.2")]
        [TestCase("S11.8.2_A3.2_T1.1.js", Description = "If Type(Primitive(x)) is String and Type(Primitive(y)) is String, then operator x > y returns ToString(x) > ToString(y)")]
        [TestCase("S11.8.2_A3.2_T1.2.js", Description = "If Type(Primitive(x)) is String and Type(Primitive(y)) is String, then operator x > y returns ToString(x) > ToString(y)")]
        public void IfTypePrimitiveXIsStringAndTypePrimitiveYIsStringThenOperatorXYReturnsToStringXToStringY(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.8.2")]
        [Category("ECMA 11.8.5")]
        [TestCase("S11.8.2_A4.1.js", Description = "If x is NaN, return false (if result in 11.8.5 is undefined, return false)")]
        public void IfXIsNaNReturnFalseIfResultIn1185IsUndefinedReturnFalse(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.8.2")]
        [Category("ECMA 11.8.5")]
        [TestCase("S11.8.2_A4.10.js", Description = "If x is a prefix of y, return false")]
        public void IfXIsAPrefixOfYReturnFalse(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.8.2")]
        [Category("ECMA 11.8.5")]
        [TestCase("S11.8.2_A4.11.js", Description = "If y is a prefix of x and x !== y, return true")]
        public void IfYIsAPrefixOfXAndXYReturnTrue(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.8.2")]
        [Category("ECMA 11.8.5")]
        [TestCase("S11.8.2_A4.12_T1.js", Description = "If neither x, nor y is a prefix of each other, returned result of strings comparison applies a simple lexicographic ordering to the sequences of code point value values")]
        [TestCase("S11.8.2_A4.12_T2.js", Description = "If neither x, nor y is a prefix of each other, returned result of strings comparison applies a simple lexicographic ordering to the sequences of code point value values")]
        public void IfNeitherXNorYIsAPrefixOfEachOtherReturnedResultOfStringsComparisonAppliesASimpleLexicographicOrderingToTheSequencesOfCodePointValueValues(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.8.2")]
        [Category("ECMA 11.8.5")]
        [TestCase("S11.8.2_A4.2.js", Description = "If y is NaN, return false (if result in 11.8.5 is undefined, return false)")]
        public void IfYIsNaNReturnFalseIfResultIn1185IsUndefinedReturnFalse(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.8.2")]
        [Category("ECMA 11.8.5")]
        [TestCase("S11.8.2_A4.3.js", Description = "If x and y are the same number value, return false")]
        public void IfXAndYAreTheSameNumberValueReturnFalse(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.8.2")]
        [Category("ECMA 11.8.5")]
        [TestCase("S11.8.2_A4.4.js", Description = "If either variable x or y is +0 and the other is -0, return false")]
        public void IfEitherVariableXOrYIs0AndTheOtherIs0ReturnFalse(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.8.2")]
        [Category("ECMA 11.8.5")]
        [TestCase("S11.8.2_A4.5.js", Description = "If x is +Infinity and x !== y, return true")]
        public void IfXIsInfinityAndXYReturnTrue(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.8.2")]
        [Category("ECMA 11.8.5")]
        [TestCase("S11.8.2_A4.6.js", Description = "If y is +Infinity, return false")]
        public void IfYIsInfinityReturnFalse(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.8.2")]
        [Category("ECMA 11.8.5")]
        [TestCase("S11.8.2_A4.7.js", Description = "If x is -Infinity, return false")]
        public void IfXIsInfinityReturnFalse(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.8.2")]
        [Category("ECMA 11.8.5")]
        [TestCase("S11.8.2_A4.8.js", Description = "If y is -Infinity and x !== y, return true")]
        public void IfYIsInfinityAndXYReturnTrue(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.8.2")]
        [Category("ECMA 11.8.5")]
        [TestCase("S11.8.2_A4.9.js", Description = "If is x greater than y and these values are both finite non-zero, return true")]
        public void IfIsXGreaterThanYAndTheseValuesAreBothFiniteNonZeroReturnTrue(string file)
        {
            RunFile(file);
        }
    }
}