// <auto-generated />
namespace IronJS.Tests.UnitTests.Sputnik.Conformance.Expressions.UnaryOperators
{
    using System;
    using NUnit.Framework;

    [TestFixture]
    public class PrefixDecrementOperatorTests : SputnikTestFixture
    {
        public PrefixDecrementOperatorTests()
            : base(@"Conformance\11_Expressions\11.4_Unary_Operators\11.4.5_Prefix_Decrement_Operator")
        {
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.4.5")]
        [Category("ECMA 11.6.3")]
        [Category("ECMA 7.2")]
        [Category("ECMA 7.3")]
        [TestCase("S11.4.5_A1.js", Description = "White Space and Line Terminator between \"--\" and UnaryExpression are allowed")]
        public void WhiteSpaceAndLineTerminatorBetweenAndUnaryExpressionAreAllowed(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.4.5")]
        [Category("ECMA 11.6.3")]
        [TestCase("S11.4.5_A2.1_T1.js", Description = "Operator --x uses GetValue and PutValue")]
        [TestCase("S11.4.5_A2.1_T2.js", Description = "Operator --x uses GetValue and PutValue")]
        [TestCase("S11.4.5_A2.1_T3.js", Description = "Operator --x uses GetValue and PutValue", ExpectedException = typeof(Exception))]
        public void OperatorXUsesGetValueAndPutValue(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.4.5")]
        [Category("ECMA 8.6.2.6")]
        [TestCase("S11.4.5_A2.2_T1.js", Description = "Operator --x uses [[Default Value]]")]
        public void OperatorXUsesDefaultValue(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.4.5")]
        [Category("ECMA 11.6.3")]
        [TestCase("S11.4.5_A3_T1.js", Description = "Operator --x returns x = ToNumber(x) - 1")]
        [TestCase("S11.4.5_A3_T2.js", Description = "Operator --x returns x = ToNumber(x) - 1")]
        [TestCase("S11.4.5_A3_T3.js", Description = "Operator --x returns x = ToNumber(x) - 1")]
        [TestCase("S11.4.5_A3_T4.js", Description = "Operator --x returns x = ToNumber(x) - 1")]
        [TestCase("S11.4.5_A3_T5.js", Description = "Operator --x returns x = ToNumber(x) - 1")]
        public void OperatorXReturnsXToNumberX1(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.4.5")]
        [Category("ECMA 11.6.3")]
        [TestCase("S11.4.5_A4_T1.js", Description = "Operator --x returns ToNumber(x) - 1")]
        [TestCase("S11.4.5_A4_T2.js", Description = "Operator --x returns ToNumber(x) - 1")]
        [TestCase("S11.4.5_A4_T3.js", Description = "Operator --x returns ToNumber(x) - 1")]
        [TestCase("S11.4.5_A4_T4.js", Description = "Operator --x returns ToNumber(x) - 1")]
        [TestCase("S11.4.5_A4_T5.js", Description = "Operator --x returns ToNumber(x) - 1")]
        public void OperatorXReturnsToNumberX1(string file)
        {
            RunFile(file);
        }
    }
}