// <auto-generated />
namespace IronJS.Tests.UnitTests.Sputnik.Conformance.LexicalConventions
{
    using System;
    using NUnit.Framework;

    [TestFixture]
    public class CommentsTests : SputnikTestFixture
    {
        public CommentsTests()
            : base(@"Conformance\07_Lexical_Conventions\7.4_Comments")
        {
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 7.4")]
        [TestCase("S7.4_A1_T1.js", Description = "Correct interpretation of single line comments")]
        [TestCase("S7.4_A1_T2.js", Description = "Correct interpretation of single line comments")]
        public void CorrectInterpretationOfSingleLineComments(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 7.4")]
        [TestCase("S7.4_A2_T1.js", Description = "Correct interpretation of multi line comments")]
        [TestCase("S7.4_A2_T2.js", Description = "Correct interpretation of multi line comments", ExpectedException = typeof(Exception))]
        public void CorrectInterpretationOfMultiLineComments(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 7.4")]
        [TestCase("S7.4_A3.js", Description = "Multi line comments cannot nest", ExpectedException = typeof(Exception))]
        public void MultiLineCommentsCannotNest(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 7.4")]
        [TestCase("S7.4_A4_T1.js", Description = "Single and Multi line comments are used together", ExpectedException = typeof(Exception))]
        [TestCase("S7.4_A4_T2.js", Description = "Single and Multi line comments are used together")]
        [TestCase("S7.4_A4_T3.js", Description = "Single and Multi line comments are used together")]
        [TestCase("S7.4_A4_T4.js", Description = "Single and Multi line comments are used together", ExpectedException = typeof(Exception))]
        [TestCase("S7.4_A4_T5.js", Description = "Single and Multi line comments are used together")]
        [TestCase("S7.4_A4_T6.js", Description = "Single and Multi line comments are used together")]
        [TestCase("S7.4_A4_T7.js", Description = "Single and Multi line comments are used together")]
        public void SingleAndMultiLineCommentsAreUsedTogether(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 7.4")]
        [TestCase("S7.4_A5.js", Description = "Single line comments can contain any Unicode character without Line Terminators")]
        public void SingleLineCommentsCanContainAnyUnicodeCharacterWithoutLineTerminators(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 7.4")]
        [TestCase("S7.4_A6.js", Description = "If multi line comments csn not nest, they can contain any Unicode character")]
        public void IfMultiLineCommentsCsnNotNestTheyCanContainAnyUnicodeCharacter(string file)
        {
            RunFile(file);
        }
    }
}