// <auto-generated />
namespace IronJS.Tests.UnitTests.Sputnik.Conformance.NativeECMAScriptObjects.ArrayObjects.PropertiesOfTheArrayPrototypeObject
{
    using System;
    using NUnit.Framework;

    [TestFixture]
    public class ArrayPrototypeReverseTests : SputnikTestFixture
    {
        public ArrayPrototypeReverseTests()
            : base(@"Conformance\15_Native_ECMA_Script_Objects\15.4_Array_Objects\15.4.4_Properties_of_the_Array_Prototype_Object\15.4.4.8_Array_prototype_reverse")
        {
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.8")]
        [TestCase("S15.4.4.8_A1_T1.js", Description = "The elements of the array are rearranged so as to reverse their order. The object is returned as the result of the call")]
        [TestCase("S15.4.4.8_A1_T2.js", Description = "The elements of the array are rearranged so as to reverse their order. The object is returned as the result of the call")]
        public void TheElementsOfTheArrayAreRearrangedSoAsToReverseTheirOrderTheObjectIsReturnedAsTheResultOfTheCall(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.8")]
        [TestCase("S15.4.4.8_A2_T1.js", Description = "The reverse function is intentionally generic. It does not require that its this value be an Array object")]
        [TestCase("S15.4.4.8_A2_T2.js", Description = "The reverse function is intentionally generic. It does not require that its this value be an Array object")]
        [TestCase("S15.4.4.8_A2_T3.js", Description = "The reverse function is intentionally generic. It does not require that its this value be an Array object")]
        public void TheReverseFunctionIsIntentionallyGenericItDoesNotRequireThatItsThisValueBeAnArrayObject(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.8")]
        [TestCase("S15.4.4.8_A3_T1.js", Description = "Check ToUint32(length) for non Array objects")]
        [TestCase("S15.4.4.8_A3_T2.js", Description = "Check ToUint32(length) for non Array objects")]
        [TestCase("S15.4.4.8_A3_T3.js", Description = "Check ToUint32(length) for non Array objects")]
        public void CheckToUint32LengthForNonArrayObjects(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.8")]
        [Category("ECMA 8.6.2.1")]
        [Category("ECMA 8.6.2.5")]
        [TestCase("S15.4.4.8_A4_T1.js", Description = "[[Get]], [[Delete]] from not an inherited property")]
        [TestCase("S15.4.4.8_A4_T2.js", Description = "[[Get]], [[Delete]] from not an inherited property")]
        public void GetDeleteFromNotAnInheritedProperty(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 12.6.4")]
        [Category("ECMA 15.2.4.7")]
        [Category("ECMA 15.4.4.8")]
        [TestCase("S15.4.4.8_A5.1.js", Description = "The length property of reverse has the attribute DontEnum")]
        public void TheLengthPropertyOfReverseHasTheAttributeDontEnum(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.4.1")]
        [Category("ECMA 15.2.4.5")]
        [Category("ECMA 15.4.4.8")]
        [TestCase("S15.4.4.8_A5.2.js", Description = "The length property of reverse has the attribute DontDelete")]
        public void TheLengthPropertyOfReverseHasTheAttributeDontDelete(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.8")]
        [TestCase("S15.4.4.8_A5.3.js", Description = "The length property of reverse has the attribute ReadOnly")]
        public void TheLengthPropertyOfReverseHasTheAttributeReadOnly(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.8")]
        [TestCase("S15.4.4.8_A5.4.js", Description = "The length property of reverse is 0")]
        public void TheLengthPropertyOfReverseIs0(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 12.6.4")]
        [Category("ECMA 15.2.4.7")]
        [Category("ECMA 15.4.4.8")]
        [TestCase("S15.4.4.8_A5.5.js", Description = "The reverse property of Array has the attribute DontEnum")]
        public void TheReversePropertyOfArrayHasTheAttributeDontEnum(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.8")]
        [TestCase("S15.4.4.8_A5.6.js", Description = "The reverse property of Array has not prototype property")]
        public void TheReversePropertyOfArrayHasNotPrototypeProperty(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.2.2")]
        [Category("ECMA 15.4.4.8")]
        [TestCase("S15.4.4.8_A5.7.js", Description = "The reverse property of Array can\'t be used as constructor")]
        public void TheReversePropertyOfArrayCanTBeUsedAsConstructor(string file)
        {
            RunFile(file);
        }
    }
}