// <auto-generated />
namespace IronJS.Tests.UnitTests.Sputnik.Conformance.NativeECMAScriptObjects.ArrayObjects.PropertiesOfTheArrayPrototypeObject
{
    using System;
    using NUnit.Framework;

    [TestFixture]
    public class ArrayPrototypeSpliceTests : SputnikTestFixture
    {
        public ArrayPrototypeSpliceTests()
            : base(@"Conformance\15_Native_ECMA_Script_Objects\15.4_Array_Objects\15.4.4_Properties_of_the_Array_Prototype_Object\15.4.4.12_Array_prototype_splice")
        {
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.12")]
        [TestCase("S15.4.4.12_A1.1_T1.js", Description = "If start is positive, use min(start, length). If deleteCount is positive, use min(deleteCount, length - start)")]
        [TestCase("S15.4.4.12_A1.1_T2.js", Description = "If start is positive, use min(start, length). If deleteCount is positive, use min(deleteCount, length - start)")]
        [TestCase("S15.4.4.12_A1.1_T3.js", Description = "If start is positive, use min(start, length). If deleteCount is positive, use min(deleteCount, length - start)")]
        [TestCase("S15.4.4.12_A1.1_T4.js", Description = "If start is positive, use min(start, length). If deleteCount is positive, use min(deleteCount, length - start)")]
        [TestCase("S15.4.4.12_A1.1_T5.js", Description = "If start is positive, use min(start, length). If deleteCount is positive, use min(deleteCount, length - start)")]
        [TestCase("S15.4.4.12_A1.1_T6.js", Description = "If start is positive, use min(start, length). If deleteCount is positive, use min(deleteCount, length - start)")]
        public void IfStartIsPositiveUseMinStartLengthIfDeleteCountIsPositiveUseMinDeleteCountLengthStart(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.12")]
        [TestCase("S15.4.4.12_A1.2_T1.js", Description = "If start is negative, use max(start + length, 0). If deleteCount is negative, use 0")]
        [TestCase("S15.4.4.12_A1.2_T2.js", Description = "If start is negative, use max(start + length, 0). If deleteCount is negative, use 0")]
        [TestCase("S15.4.4.12_A1.2_T3.js", Description = "If start is negative, use max(start + length, 0). If deleteCount is negative, use 0")]
        [TestCase("S15.4.4.12_A1.2_T4.js", Description = "If start is negative, use max(start + length, 0). If deleteCount is negative, use 0")]
        [TestCase("S15.4.4.12_A1.2_T5.js", Description = "If start is negative, use max(start + length, 0). If deleteCount is negative, use 0")]
        public void IfStartIsNegativeUseMaxStartLength0IfDeleteCountIsNegativeUse0(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.12")]
        [TestCase("S15.4.4.12_A1.3_T1.js", Description = "If start is positive, use min(start, length). If deleteCount is negative, use 0")]
        [TestCase("S15.4.4.12_A1.3_T2.js", Description = "If start is positive, use min(start, length). If deleteCount is negative, use 0")]
        [TestCase("S15.4.4.12_A1.3_T3.js", Description = "If start is positive, use min(start, length). If deleteCount is negative, use 0")]
        [TestCase("S15.4.4.12_A1.3_T4.js", Description = "If start is positive, use min(start, length). If deleteCount is negative, use 0")]
        [TestCase("S15.4.4.12_A1.3_T5.js", Description = "If start is positive, use min(start, length). If deleteCount is negative, use 0")]
        public void IfStartIsPositiveUseMinStartLengthIfDeleteCountIsNegativeUse0(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.12")]
        [TestCase("S15.4.4.12_A1.4_T1.js", Description = "If start is negative, use max(start + length, 0). If deleteCount is positive, use min(deleteCount, length - start)")]
        [TestCase("S15.4.4.12_A1.4_T2.js", Description = "If start is negative, use max(start + length, 0). If deleteCount is positive, use min(deleteCount, length - start)")]
        [TestCase("S15.4.4.12_A1.4_T3.js", Description = "If start is negative, use max(start + length, 0). If deleteCount is positive, use min(deleteCount, length - start)")]
        [TestCase("S15.4.4.12_A1.4_T4.js", Description = "If start is negative, use max(start + length, 0). If deleteCount is positive, use min(deleteCount, length - start)")]
        [TestCase("S15.4.4.12_A1.4_T5.js", Description = "If start is negative, use max(start + length, 0). If deleteCount is positive, use min(deleteCount, length - start)")]
        [TestCase("S15.4.4.12_A1.4_T6.js", Description = "If start is negative, use max(start + length, 0). If deleteCount is positive, use min(deleteCount, length - start)")]
        public void IfStartIsNegativeUseMaxStartLength0IfDeleteCountIsPositiveUseMinDeleteCountLengthStart(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.12")]
        [TestCase("S15.4.4.12_A1.5_T1.js", Description = "Splice with undefined arguments")]
        [TestCase("S15.4.4.12_A1.5_T2.js", Description = "Splice with undefined arguments")]
        public void SpliceWithUndefinedArguments(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.12")]
        [TestCase("S15.4.4.12_A2.1_T1.js", Description = "Operator use ToInteger from start")]
        [TestCase("S15.4.4.12_A2.1_T2.js", Description = "Operator use ToInteger from start")]
        [TestCase("S15.4.4.12_A2.1_T3.js", Description = "Operator use ToInteger from start")]
        [TestCase("S15.4.4.12_A2.1_T4.js", Description = "Operator use ToInteger from start")]
        [TestCase("S15.4.4.12_A2.1_T5.js", Description = "Operator use ToInteger from start")]
        public void OperatorUseToIntegerFromStart(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.12")]
        [TestCase("S15.4.4.12_A2.2_T1.js", Description = "Operator use ToInteger from deleteCount")]
        [TestCase("S15.4.4.12_A2.2_T2.js", Description = "Operator use ToInteger from deleteCount")]
        [TestCase("S15.4.4.12_A2.2_T3.js", Description = "Operator use ToInteger from deleteCount")]
        [TestCase("S15.4.4.12_A2.2_T4.js", Description = "Operator use ToInteger from deleteCount")]
        [TestCase("S15.4.4.12_A2.2_T5.js", Description = "Operator use ToInteger from deleteCount")]
        public void OperatorUseToIntegerFromDeleteCount(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.12")]
        [TestCase("S15.4.4.12_A2_T1.js", Description = "The splice function is intentionally generic. It does not require that its this value be an Array object")]
        [TestCase("S15.4.4.12_A2_T2.js", Description = "The splice function is intentionally generic. It does not require that its this value be an Array object")]
        [TestCase("S15.4.4.12_A2_T3.js", Description = "The splice function is intentionally generic. It does not require that its this value be an Array object")]
        [TestCase("S15.4.4.12_A2_T4.js", Description = "The splice function is intentionally generic. It does not require that its this value be an Array object")]
        public void TheSpliceFunctionIsIntentionallyGenericItDoesNotRequireThatItsThisValueBeAnArrayObject(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.12")]
        [TestCase("S15.4.4.12_A3_T1.js", Description = "Check ToUint32(length) for non Array objects")]
        [TestCase("S15.4.4.12_A3_T2.js", Description = "Check ToUint32(length) for non Array objects")]
        [TestCase("S15.4.4.12_A3_T3.js", Description = "Check ToUint32(length) for non Array objects")]
        public void CheckToUint32LengthForNonArrayObjects(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.12")]
        [Category("ECMA 8.6.2.1")]
        [TestCase("S15.4.4.12_A4_T1.js", Description = "[[Get]] from not an inherited property")]
        [TestCase("S15.4.4.12_A4_T2.js", Description = "[[Get]] from not an inherited property")]
        [TestCase("S15.4.4.12_A4_T3.js", Description = "[[Get]] from not an inherited property")]
        public void GetFromNotAnInheritedProperty(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 12.6.4")]
        [Category("ECMA 15.2.4.7")]
        [Category("ECMA 15.4.4.12")]
        [TestCase("S15.4.4.12_A5.1.js", Description = "The length property of splice has the attribute DontEnum")]
        public void TheLengthPropertyOfSpliceHasTheAttributeDontEnum(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.4.1")]
        [Category("ECMA 15.2.4.5")]
        [Category("ECMA 15.4.4.12")]
        [TestCase("S15.4.4.12_A5.2.js", Description = "The length property of splice has the attribute DontDelete")]
        public void TheLengthPropertyOfSpliceHasTheAttributeDontDelete(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.12")]
        [TestCase("S15.4.4.12_A5.3.js", Description = "The length property of splice has the attribute ReadOnly")]
        public void TheLengthPropertyOfSpliceHasTheAttributeReadOnly(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.12")]
        [TestCase("S15.4.4.12_A5.4.js", Description = "The length property of splice is 2")]
        public void TheLengthPropertyOfSpliceIs2(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 12.6.4")]
        [Category("ECMA 15.2.4.7")]
        [Category("ECMA 15.4.4.12")]
        [TestCase("S15.4.4.12_A5.5.js", Description = "The splice property of Array has the attribute DontEnum")]
        public void TheSplicePropertyOfArrayHasTheAttributeDontEnum(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.12")]
        [TestCase("S15.4.4.12_A5.6.js", Description = "The splice property of Array has not prototype property")]
        public void TheSplicePropertyOfArrayHasNotPrototypeProperty(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.2.2")]
        [Category("ECMA 15.4.4.12")]
        [TestCase("S15.4.4.12_A5.7.js", Description = "The splice property of Array can\'t be used as constructor")]
        public void TheSplicePropertyOfArrayCanTBeUsedAsConstructor(string file)
        {
            RunFile(file);
        }
    }
}