// <auto-generated />
namespace IronJS.Tests.UnitTests.Sputnik.Conformance.NativeECMAScriptObjects.ArrayObjects.PropertiesOfTheArrayPrototypeObject
{
    using System;
    using NUnit.Framework;

    [TestFixture]
    public class ArrayPrototypeToStringTests : SputnikTestFixture
    {
        public ArrayPrototypeToStringTests()
            : base(@"Conformance\15_Native_ECMA_Script_Objects\15.4_Array_Objects\15.4.4_Properties_of_the_Array_Prototype_Object\15.4.4.2_Array_prototype_toString")
        {
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.2")]
        [TestCase("S15.4.4.2_A1_T1.js", Description = "The result of calling this function is the same as if the built-in join method were invoked for this object with no argument")]
        [TestCase("S15.4.4.2_A1_T2.js", Description = "The result of calling this function is the same as if the built-in join method were invoked for this object with no argument")]
        [TestCase("S15.4.4.2_A1_T3.js", Description = "The result of calling this function is the same as if the built-in join method were invoked for this object with no argument")]
        [TestCase("S15.4.4.2_A1_T4.js", Description = "The result of calling this function is the same as if the built-in join method were invoked for this object with no argument")]
        public void TheResultOfCallingThisFunctionIsTheSameAsIfTheBuiltInJoinMethodWereInvokedForThisObjectWithNoArgument(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.2")]
        [TestCase("S15.4.4.2_A2_T1.js", Description = "The toString function is not generic. it throws a TypeError exception if its this value is not an Array object")]
        public void TheToStringFunctionIsNotGenericItThrowsATypeErrorExceptionIfItsThisValueIsNotAnArrayObject(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.2")]
        [Category("ECMA 8.6.2.1")]
        [TestCase("S15.4.4.2_A3_T1.js", Description = "[[Get]] from not an inherited property")]
        public void GetFromNotAnInheritedProperty(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 12.6.4")]
        [Category("ECMA 15.2.4.7")]
        [Category("ECMA 15.4.4.2")]
        [TestCase("S15.4.4.2_A4.1.js", Description = "The length property of toString has the attribute DontEnum")]
        public void TheLengthPropertyOfToStringHasTheAttributeDontEnum(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.4.1")]
        [Category("ECMA 15.2.4.5")]
        [Category("ECMA 15.4.4.2")]
        [TestCase("S15.4.4.2_A4.2.js", Description = "The length property of toString has the attribute DontDelete")]
        public void TheLengthPropertyOfToStringHasTheAttributeDontDelete(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.2")]
        [TestCase("S15.4.4.2_A4.3.js", Description = "The length property of toString has the attribute ReadOnly")]
        public void TheLengthPropertyOfToStringHasTheAttributeReadOnly(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.2")]
        [TestCase("S15.4.4.2_A4.4.js", Description = "The length property of toString is 0")]
        public void TheLengthPropertyOfToStringIs0(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 12.6.4")]
        [Category("ECMA 15.2.4.7")]
        [Category("ECMA 15.4.4.2")]
        [TestCase("S15.4.4.2_A4.5.js", Description = "The toString property of Array has the attribute DontEnum")]
        public void TheToStringPropertyOfArrayHasTheAttributeDontEnum(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.4.4.2")]
        [TestCase("S15.4.4.2_A4.6.js", Description = "The toString property of Array has not prototype property")]
        public void TheToStringPropertyOfArrayHasNotPrototypeProperty(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.2.2")]
        [Category("ECMA 15.4.4.2")]
        [TestCase("S15.4.4.2_A4.7.js", Description = "The toString property of Array can\'t be used as constructor")]
        public void TheToStringPropertyOfArrayCanTBeUsedAsConstructor(string file)
        {
            RunFile(file);
        }
    }
}