// <auto-generated />
namespace IronJS.Tests.UnitTests.Sputnik.Conformance.NativeECMAScriptObjects.FunctionObjects
{
    using System;
    using NUnit.Framework;

    [TestFixture]
    public class FunctionObjectsTests : SputnikTestFixture
    {
        public FunctionObjectsTests()
            : base(@"Conformance\15_Native_ECMA_Script_Objects\15.3_Function_Objects")
        {
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.3.1")]
        [TestCase("S15.3.1_A1_T1.js", Description = "The function call Function(\u2026) is equivalent to the object creation expression new Function(\u2026) with the same arguments. @description: Create simple functions and check returned values")]
        public void TheFunctionCallFunctionIsEquivalentToTheObjectCreationExpressionNewFunctionWithTheSameArgumentsDescriptionCreateSimpleFunctionsAndCheckReturnedValues(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.3")]
        [TestCase("S15.3_A1.js", Description = "Function is the property of global")]
        public void FunctionIsThePropertyOfGlobal(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 10.2.3")]
        [Category("ECMA 15.3")]
        [Category("ECMA 15.3.2.1")]
        [TestCase("S15.3_A2_T1.js", Description = "Since applying the \"call\" method to Function constructor themself leads to creating a new function instance, the second argument must be a valid function body")]
        [TestCase("S15.3_A2_T2.js", Description = "Since applying the \"call\" method to Function constructor themself leads to creating a new function instance, the second argument must be a valid function body")]
        public void SinceApplyingTheCallMethodToFunctionConstructorThemselfLeadsToCreatingANewFunctionInstanceTheSecondArgumentMustBeAValidFunctionBody(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 10.2.3")]
        [Category("ECMA 15.3")]
        [TestCase("S15.3_A3_T1.js", Description = "Since when call is used for Function constructor themself new function instance creates and then first argument(thisArg) should be ignored")]
        [TestCase("S15.3_A3_T2.js", Description = "Since when call is used for Function constructor themself new function instance creates and then first argument(thisArg) should be ignored")]
        [TestCase("S15.3_A3_T3.js", Description = "Since when call is used for Function constructor themself new function instance creates and then first argument(thisArg) should be ignored")]
        [TestCase("S15.3_A3_T4.js", Description = "Since when call is used for Function constructor themself new function instance creates and then first argument(thisArg) should be ignored")]
        [TestCase("S15.3_A3_T5.js", Description = "Since when call is used for Function constructor themself new function instance creates and then first argument(thisArg) should be ignored")]
        [TestCase("S15.3_A3_T6.js", Description = "Since when call is used for Function constructor themself new function instance creates and then first argument(thisArg) should be ignored")]
        public void SinceWhenCallIsUsedForFunctionConstructorThemselfNewFunctionInstanceCreatesAndThenFirstArgumentThisArgShouldBeIgnored(string file)
        {
            RunFile(file);
        }
    }
}