// <auto-generated />
namespace IronJS.Tests.UnitTests.Sputnik.Conformance.NativeECMAScriptObjects.FunctionObjects.PropertiesOfTheFunctionPrototypeObject
{
    using System;
    using NUnit.Framework;

    [TestFixture]
    public class FunctionPrototypeToStringTests : SputnikTestFixture
    {
        public FunctionPrototypeToStringTests()
            : base(@"Conformance\15_Native_ECMA_Script_Objects\15.3_Function_Objects\15.3.4_Properties_of_the_Function_Prototype_Object\15.3.4.2_Function.prototype.toString")
        {
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.3.4.2")]
        [TestCase("S15.3.4.2_A1_T1.js", Description = "An implementation-dependent representation of the function is returned. This representation has the syntax of a FunctionDeclaration")]
        public void AnImplementationDependentRepresentationOfTheFunctionIsReturnedThisRepresentationHasTheSyntaxOfAFunctionDeclaration(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.3.4.2")]
        [TestCase("S15.3.4.2_A10.js", Description = "The Function.prototype.toString.length property has the attribute ReadOnly")]
        public void TheFunctionPrototypeToStringLengthPropertyHasTheAttributeReadOnly(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.3.4.2")]
        [TestCase("S15.3.4.2_A11.js", Description = "The length property of the toString method is 0")]
        public void TheLengthPropertyOfTheToStringMethodIs0(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 13.2")]
        [Category("ECMA 15.3.4.2")]
        [TestCase("S15.3.4.2_A6.js", Description = "Function.prototype.toString has not prototype property")]
        public void FunctionPrototypeToStringHasNotPrototypeProperty(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 13.2")]
        [Category("ECMA 15.3.4.2")]
        [TestCase("S15.3.4.2_A7.js", Description = "Function.prototype.toString can\'t be used as constructor")]
        public void FunctionPrototypeToStringCanTBeUsedAsConstructor(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.3.4.2")]
        [TestCase("S15.3.4.2_A8.js", Description = "The Function.prototype.toString.length property has the attribute DontEnum")]
        public void TheFunctionPrototypeToStringLengthPropertyHasTheAttributeDontEnum(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.3.4.2")]
        [TestCase("S15.3.4.2_A9.js", Description = "The Function.prototype.toString.length property has the attribute DontDelete")]
        public void TheFunctionPrototypeToStringLengthPropertyHasTheAttributeDontDelete(string file)
        {
            RunFile(file);
        }
    }
}