// <auto-generated />
namespace IronJS.Tests.UnitTests.Sputnik.Conformance.NativeECMAScriptObjects.FunctionObjects.PropertiesOfTheFunctionPrototypeObject
{
    using System;
    using NUnit.Framework;

    [TestFixture]
    public class PropertiesOfTheFunctionPrototypeObjectTests : SputnikTestFixture
    {
        public PropertiesOfTheFunctionPrototypeObjectTests()
            : base(@"Conformance\15_Native_ECMA_Script_Objects\15.3_Function_Objects\15.3.4_Properties_of_the_Function_Prototype_Object")
        {
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.3.4.1")]
        [TestCase("S15.3.4.1_A1_T1.js", Description = "The initial value of Function.prototype.constructor is the built-in Function constructor")]
        [TestCase("S15.3.4.1_A1_T2.js", Description = "The initial value of Function.prototype.constructor is the built-in Function constructor")]
        public void TheInitialValueOfFunctionPrototypeConstructorIsTheBuiltInFunctionConstructor(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.3.4")]
        [TestCase("S15.3.4_A1.js", Description = "The Function prototype object is itself a Function object (its [[Class]] is \"Function\")")]
        public void TheFunctionPrototypeObjectIsItselfAFunctionObjectItsClassIsFunction(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.3.4")]
        [TestCase("S15.3.4_A2_T1.js", Description = "The Function prototype object is itself a Function object that, when invoked, accepts any arguments and returns undefined")]
        [TestCase("S15.3.4_A2_T2.js", Description = "The Function prototype object is itself a Function object that, when invoked, accepts any arguments and returns undefined")]
        [TestCase("S15.3.4_A2_T3.js", Description = "The Function prototype object is itself a Function object that, when invoked, accepts any arguments and returns undefined")]
        public void TheFunctionPrototypeObjectIsItselfAFunctionObjectThatWhenInvokedAcceptsAnyArgumentsAndReturnsUndefined(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.3.2.1")]
        [Category("ECMA 15.3.4")]
        [TestCase("S15.3.4_A3_T1.js", Description = "The value of the internal [[Prototype]] property of the Function prototype object is the Object prototype object (15.3.2.1)")]
        [TestCase("S15.3.4_A3_T2.js", Description = "The value of the internal [[Prototype]] property of the Function prototype object is the Object prototype object (15.3.2.1)")]
        public void TheValueOfTheInternalPrototypePropertyOfTheFunctionPrototypeObjectIsTheObjectPrototypeObject15321(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.3.4")]
        [TestCase("S15.3.4_A4.js", Description = "The Function prototype object does not have a valueOf property of its own. however, it inherits the valueOf property from the Object prototype Object")]
        public void TheFunctionPrototypeObjectDoesNotHaveAValueOfPropertyOfItsOwnHoweverItInheritsTheValueOfPropertyFromTheObjectPrototypeObject(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.3.4")]
        [TestCase("S15.3.4_A5.js", Description = "The Function prototype object is itself a Function object without [[create]] property")]
        public void TheFunctionPrototypeObjectIsItselfAFunctionObjectWithoutCreateProperty(string file)
        {
            RunFile(file);
        }
    }
}