// <auto-generated />
namespace IronJS.Tests.UnitTests.Sputnik.Conformance.NativeECMAScriptObjects.ObjectObjects.PropertiesOfTheObjectPrototypeObject
{
    using System;
    using NUnit.Framework;

    [TestFixture]
    public class ObjectPrototypeToStringTests : SputnikTestFixture
    {
        public ObjectPrototypeToStringTests()
            : base(@"Conformance\15_Native_ECMA_Script_Objects\15.2_Object_Objects\15.2.4_Properties_of_the_Object_Prototype_Object\15.2.4.2_Object.prototype.toString")
        {
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.2.4.2")]
        [TestCase("S15.2.4.2_A1.js", Description = "When the toString method is called, the following steps are taken: i) Get the [[Class]] property of this object ii) Compute a string value by concatenating the three strings \"[object \", Result(1), and \"]\" iii) Return Result(2)")]
        public void WhenTheToStringMethodIsCalledTheFollowingStepsAreTakenIGetTheClassPropertyOfThisObjectIiComputeAStringValueByConcatenatingTheThreeStringsObjectResult1AndIiiReturnResult2(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.2.4.2")]
        [TestCase("S15.2.4.2_A10.js", Description = "The Object.prototype.toString.length property has the attribute ReadOnly")]
        public void TheObjectPrototypeToStringLengthPropertyHasTheAttributeReadOnly(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.2.4.2")]
        [TestCase("S15.2.4.2_A11.js", Description = "The length property of the toString method is 0")]
        public void TheLengthPropertyOfTheToStringMethodIs0(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 13.2")]
        [Category("ECMA 15.2.4.2")]
        [TestCase("S15.2.4.2_A6.js", Description = "Object.prototype.toString has not prototype property")]
        public void ObjectPrototypeToStringHasNotPrototypeProperty(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 13.2")]
        [Category("ECMA 15.2.4.2")]
        [TestCase("S15.2.4.2_A7.js", Description = "Object.prototype.toString can\'t be used as a constructor")]
        public void ObjectPrototypeToStringCanTBeUsedAsAConstructor(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.2.4.2")]
        [TestCase("S15.2.4.2_A8.js", Description = "The Object.prototype.toString.length property has the attribute DontEnum")]
        public void TheObjectPrototypeToStringLengthPropertyHasTheAttributeDontEnum(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.2.4.2")]
        [TestCase("S15.2.4.2_A9.js", Description = "The Object.prototype.toString.length property has the attribute DontDelete")]
        public void TheObjectPrototypeToStringLengthPropertyHasTheAttributeDontDelete(string file)
        {
            RunFile(file);
        }
    }
}