// <auto-generated />
namespace IronJS.Tests.UnitTests.Sputnik.Conformance.NativeECMAScriptObjects.RegExpObjects.PatternSemantics
{
    using System;
    using NUnit.Framework;

    [TestFixture]
    public class AtomTests : SputnikTestFixture
    {
        public AtomTests()
            : base(@"Conformance\15_Native_ECMA_Script_Objects\15.10_RegExp_Objects\15.10.2_Pattern_Semantics\15.10.2.8_Atom")
        {
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.10.2.8")]
        [TestCase("S15.10.2.8_A1_T1.js", Description = "The form (?= Disjunction ) specifies a zero-width positive lookahead. In order for it to succeed, the pattern inside Disjunction must match at the current position, but the current position is not advanced before matching the sequel. If Disjunction can match at the current position in several ways, only the first one is tried")]
        [TestCase("S15.10.2.8_A1_T2.js", Description = "The form (?= Disjunction ) specifies a zero-width positive lookahead. In order for it to succeed, the pattern inside Disjunction must match at the current position, but the current position is not advanced before matching the sequel. If Disjunction can match at the current position in several ways, only the first one is tried")]
        [TestCase("S15.10.2.8_A1_T3.js", Description = "The form (?= Disjunction ) specifies a zero-width positive lookahead. In order for it to succeed, the pattern inside Disjunction must match at the current position, but the current position is not advanced before matching the sequel. If Disjunction can match at the current position in several ways, only the first one is tried")]
        [TestCase("S15.10.2.8_A1_T4.js", Description = "The form (?= Disjunction ) specifies a zero-width positive lookahead. In order for it to succeed, the pattern inside Disjunction must match at the current position, but the current position is not advanced before matching the sequel. If Disjunction can match at the current position in several ways, only the first one is tried")]
        [TestCase("S15.10.2.8_A1_T5.js", Description = "The form (?= Disjunction ) specifies a zero-width positive lookahead. In order for it to succeed, the pattern inside Disjunction must match at the current position, but the current position is not advanced before matching the sequel. If Disjunction can match at the current position in several ways, only the first one is tried")]
        public void TheFormDisjunctionSpecifiesAZeroWidthPositiveLookaheadInOrderForItToSucceedThePatternInsideDisjunctionMustMatchAtTheCurrentPositionButTheCurrentPositionIsNotAdvancedBeforeMatchingTheSequelIfDisjunctionCanMatchAtTheCurrentPositionInSeveralWaysOnlyTheFirstOneIsTried(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.10.2.8")]
        [TestCase("S15.10.2.8_A2_T1.js", Description = "The form (?! Disjunction ) specifies a zero-width negative lookahead. In order for it to succeed, the pattern inside Disjunction must fail to match at the current position. The current position is not advanced before matching the sequel")]
        [TestCase("S15.10.2.8_A2_T10.js", Description = "The form (?! Disjunction ) specifies a zero-width negative lookahead. In order for it to succeed, the pattern inside Disjunction must fail to match at the current position. The current position is not advanced before matching the sequel")]
        [TestCase("S15.10.2.8_A2_T11.js", Description = "The form (?! Disjunction ) specifies a zero-width negative lookahead. In order for it to succeed, the pattern inside Disjunction must fail to match at the current position. The current position is not advanced before matching the sequel")]
        [TestCase("S15.10.2.8_A2_T2.js", Description = "The form (?! Disjunction ) specifies a zero-width negative lookahead. In order for it to succeed, the pattern inside Disjunction must fail to match at the current position. The current position is not advanced before matching the sequel")]
        [TestCase("S15.10.2.8_A2_T3.js", Description = "The form (?! Disjunction ) specifies a zero-width negative lookahead. In order for it to succeed, the pattern inside Disjunction must fail to match at the current position. The current position is not advanced before matching the sequel")]
        [TestCase("S15.10.2.8_A2_T4.js", Description = "The form (?! Disjunction ) specifies a zero-width negative lookahead. In order for it to succeed, the pattern inside Disjunction must fail to match at the current position. The current position is not advanced before matching the sequel")]
        [TestCase("S15.10.2.8_A2_T5.js", Description = "The form (?! Disjunction ) specifies a zero-width negative lookahead. In order for it to succeed, the pattern inside Disjunction must fail to match at the current position. The current position is not advanced before matching the sequel")]
        [TestCase("S15.10.2.8_A2_T6.js", Description = "The form (?! Disjunction ) specifies a zero-width negative lookahead. In order for it to succeed, the pattern inside Disjunction must fail to match at the current position. The current position is not advanced before matching the sequel")]
        [TestCase("S15.10.2.8_A2_T7.js", Description = "The form (?! Disjunction ) specifies a zero-width negative lookahead. In order for it to succeed, the pattern inside Disjunction must fail to match at the current position. The current position is not advanced before matching the sequel")]
        [TestCase("S15.10.2.8_A2_T8.js", Description = "The form (?! Disjunction ) specifies a zero-width negative lookahead. In order for it to succeed, the pattern inside Disjunction must fail to match at the current position. The current position is not advanced before matching the sequel")]
        [TestCase("S15.10.2.8_A2_T9.js", Description = "The form (?! Disjunction ) specifies a zero-width negative lookahead. In order for it to succeed, the pattern inside Disjunction must fail to match at the current position. The current position is not advanced before matching the sequel")]
        public void TheFormDisjunctionSpecifiesAZeroWidthNegativeLookaheadInOrderForItToSucceedThePatternInsideDisjunctionMustFailToMatchAtTheCurrentPositionTheCurrentPositionIsNotAdvancedBeforeMatchingTheSequel(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.10.2.8")]
        [TestCase("S15.10.2.8_A3_T1.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T10.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T11.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T12.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T13.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T14.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T15.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T16.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T17.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T18.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T19.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T2.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T20.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T21.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T22.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T23.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T24.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T25.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T26.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T27.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T28.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T29.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T3.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T30.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T31.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T32.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T33.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T4.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T5.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T6.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T7.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T8.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        [TestCase("S15.10.2.8_A3_T9.js", Description = "Parentheses of the form ( Disjunction ) serve both to group the components of the Disjunction pattern together and to save the result of the match. The result can be used either in a backreference (\\ followed by a nonzero decimal number), referenced in a replace string, or returned as part of an array from the regular expression matching function")]
        public void ParenthesesOfTheFormDisjunctionServeBothToGroupTheComponentsOfTheDisjunctionPatternTogetherAndToSaveTheResultOfTheMatchTheResultCanBeUsedEitherInABackreferenceFollowedByANonzeroDecimalNumberReferencedInAReplaceStringOrReturnedAsPartOfAnArrayFromTheRegularExpressionMatchingFunction(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.10.2.8")]
        [TestCase("S15.10.2.8_A4_T1.js", Description = "The production Atom :: . evaluates as follows: i) Let A be the set of all characters except the four line terminator characters <LF>, <CR>, <LS>, or <PS> ii) Call CharacterSetMatcher(A, false) and return its Matcher result")]
        [TestCase("S15.10.2.8_A4_T2.js", Description = "The production Atom :: . evaluates as follows: i) Let A be the set of all characters except the four line terminator characters <LF>, <CR>, <LS>, or <PS> ii) Call CharacterSetMatcher(A, false) and return its Matcher result")]
        [TestCase("S15.10.2.8_A4_T3.js", Description = "The production Atom :: . evaluates as follows: i) Let A be the set of all characters except the four line terminator characters <LF>, <CR>, <LS>, or <PS> ii) Call CharacterSetMatcher(A, false) and return its Matcher result")]
        [TestCase("S15.10.2.8_A4_T4.js", Description = "The production Atom :: . evaluates as follows: i) Let A be the set of all characters except the four line terminator characters <LF>, <CR>, <LS>, or <PS> ii) Call CharacterSetMatcher(A, false) and return its Matcher result")]
        [TestCase("S15.10.2.8_A4_T5.js", Description = "The production Atom :: . evaluates as follows: i) Let A be the set of all characters except the four line terminator characters <LF>, <CR>, <LS>, or <PS> ii) Call CharacterSetMatcher(A, false) and return its Matcher result")]
        [TestCase("S15.10.2.8_A4_T6.js", Description = "The production Atom :: . evaluates as follows: i) Let A be the set of all characters except the four line terminator characters <LF>, <CR>, <LS>, or <PS> ii) Call CharacterSetMatcher(A, false) and return its Matcher result")]
        [TestCase("S15.10.2.8_A4_T7.js", Description = "The production Atom :: . evaluates as follows: i) Let A be the set of all characters except the four line terminator characters <LF>, <CR>, <LS>, or <PS> ii) Call CharacterSetMatcher(A, false) and return its Matcher result")]
        [TestCase("S15.10.2.8_A4_T8.js", Description = "The production Atom :: . evaluates as follows: i) Let A be the set of all characters except the four line terminator characters <LF>, <CR>, <LS>, or <PS> ii) Call CharacterSetMatcher(A, false) and return its Matcher result")]
        [TestCase("S15.10.2.8_A4_T9.js", Description = "The production Atom :: . evaluates as follows: i) Let A be the set of all characters except the four line terminator characters <LF>, <CR>, <LS>, or <PS> ii) Call CharacterSetMatcher(A, false) and return its Matcher result")]
        public void TheProductionAtomEvaluatesAsFollowsILetABeTheSetOfAllCharactersExceptTheFourLineTerminatorCharactersLFCRLSOrPSIiCallCharacterSetMatcherAFalseAndReturnItsMatcherResult(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.10.2.8")]
        [TestCase("S15.10.2.8_A5_T1.js", Description = "In case-insignificant matches all characters are implicitly converted to upper case immediately before they are compared")]
        [TestCase("S15.10.2.8_A5_T2.js", Description = "In case-insignificant matches all characters are implicitly converted to upper case immediately before they are compared")]
        public void InCaseInsignificantMatchesAllCharactersAreImplicitlyConvertedToUpperCaseImmediatelyBeforeTheyAreCompared(string file)
        {
            RunFile(file);
        }
    }
}