// <auto-generated />
namespace IronJS.Tests.UnitTests.Sputnik.Conformance.NativeECMAScriptObjects.RegExpObjects
{
    using System;
    using NUnit.Framework;

    [TestFixture]
    public class PropertiesOfTheRegExpConstructorTests : SputnikTestFixture
    {
        public PropertiesOfTheRegExpConstructorTests()
            : base(@"Conformance\15_Native_ECMA_Script_Objects\15.10_RegExp_Objects\15.10.5_Properties_of_the_RegExp_Constructor")
        {
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.10.5.1")]
        [TestCase("S15.10.5.1_A1.js", Description = "The RegExp has property prototype")]
        public void TheRegExpHasPropertyPrototype(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.10.5.1")]
        [TestCase("S15.10.5.1_A2.js", Description = "The RegExp.prototype property has the attribute DontEnum")]
        public void TheRegExpPrototypePropertyHasTheAttributeDontEnum(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.10.5.1")]
        [TestCase("S15.10.5.1_A3.js", Description = "The RegExp.prototype property has the attribute DontDelete")]
        public void TheRegExpPrototypePropertyHasTheAttributeDontDelete(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.10.5.1")]
        [TestCase("S15.10.5.1_A4.js", Description = "The RegExp.prototype property has the attribute ReadOnly")]
        public void TheRegExpPrototypePropertyHasTheAttributeReadOnly(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.10.5")]
        [TestCase("S15.10.5_A1.js", Description = "RegExp constructor has length property whose value is 2")]
        public void RegExpConstructorHasLengthPropertyWhoseValueIs2(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.10.5")]
        [TestCase("S15.10.5_A2_T1.js", Description = "The value of the internal [[Prototype]] property of the RegExp constructor is the Function prototype object")]
        [TestCase("S15.10.5_A2_T2.js", Description = "The value of the internal [[Prototype]] property of the RegExp constructor is the Function prototype object")]
        public void TheValueOfTheInternalPrototypePropertyOfTheRegExpConstructorIsTheFunctionPrototypeObject(string file)
        {
            RunFile(file);
        }
    }
}