// <auto-generated />
namespace IronJS.Tests.UnitTests.Sputnik.Conformance.NativeECMAScriptObjects.RegExpObjects
{
    using System;
    using NUnit.Framework;

    [TestFixture]
    public class TheRegExpConstructorTests : SputnikTestFixture
    {
        public TheRegExpConstructorTests()
            : base(@"Conformance\15_Native_ECMA_Script_Objects\15.10_RegExp_Objects\15.10.4_The_RegExp_Constructor")
        {
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.10.4.1")]
        [TestCase("S15.10.4.1_A1_T1.js", Description = "If pattern is an object R whose [[Class]] property is \"RegExp\" and flags is undefined, then let P be the pattern used to construct R and let F be the flags used to construct R")]
        [TestCase("S15.10.4.1_A1_T2.js", Description = "If pattern is an object R whose [[Class]] property is \"RegExp\" and flags is undefined, then let P be the pattern used to construct R and let F be the flags used to construct R")]
        [TestCase("S15.10.4.1_A1_T3.js", Description = "If pattern is an object R whose [[Class]] property is \"RegExp\" and flags is undefined, then let P be the pattern used to construct R and let F be the flags used to construct R")]
        [TestCase("S15.10.4.1_A1_T4.js", Description = "If pattern is an object R whose [[Class]] property is \"RegExp\" and flags is undefined, then let P be the pattern used to construct R and let F be the flags used to construct R")]
        [TestCase("S15.10.4.1_A1_T5.js", Description = "If pattern is an object R whose [[Class]] property is \"RegExp\" and flags is undefined, then let P be the pattern used to construct R and let F be the flags used to construct R")]
        public void IfPatternIsAnObjectRWhoseClassPropertyIsRegExpAndFlagsIsUndefinedThenLetPBeThePatternUsedToConstructRAndLetFBeTheFlagsUsedToConstructR(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.10.4.1")]
        [TestCase("S15.10.4.1_A2_T1.js", Description = "If pattern is an object R whose [[Class]] property is \"RegExp\" and flags is not undefined, then throw a TypeError exception")]
        [TestCase("S15.10.4.1_A2_T2.js", Description = "If pattern is an object R whose [[Class]] property is \"RegExp\" and flags is not undefined, then throw a TypeError exception")]
        public void IfPatternIsAnObjectRWhoseClassPropertyIsRegExpAndFlagsIsNotUndefinedThenThrowATypeErrorException(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.10.4.1")]
        [TestCase("S15.10.4.1_A3_T1.js", Description = "let P be the empty string if pattern is undefined")]
        [TestCase("S15.10.4.1_A3_T2.js", Description = "let P be the empty string if pattern is undefined")]
        [TestCase("S15.10.4.1_A3_T3.js", Description = "let P be the empty string if pattern is undefined")]
        [TestCase("S15.10.4.1_A3_T4.js", Description = "let P be the empty string if pattern is undefined")]
        [TestCase("S15.10.4.1_A3_T5.js", Description = "let P be the empty string if pattern is undefined")]
        public void LetPBeTheEmptyStringIfPatternIsUndefined(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.10.4.1")]
        [TestCase("S15.10.4.1_A4_T1.js", Description = "let F be the empty string if flags is undefined")]
        [TestCase("S15.10.4.1_A4_T2.js", Description = "let F be the empty string if flags is undefined")]
        [TestCase("S15.10.4.1_A4_T3.js", Description = "let F be the empty string if flags is undefined")]
        [TestCase("S15.10.4.1_A4_T4.js", Description = "let F be the empty string if flags is undefined")]
        [TestCase("S15.10.4.1_A4_T5.js", Description = "let F be the empty string if flags is undefined")]
        public void LetFBeTheEmptyStringIfFlagsIsUndefined(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.10.4.1")]
        [TestCase("S15.10.4.1_A5_T1.js", Description = "If F contains any character other than \'g\', \'i\', or \'m\', or if it contains the same one more than once, then throw a SyntaxError exception")]
        [TestCase("S15.10.4.1_A5_T2.js", Description = "If F contains any character other than \'g\', \'i\', or \'m\', or if it contains the same one more than once, then throw a SyntaxError exception")]
        [TestCase("S15.10.4.1_A5_T3.js", Description = "If F contains any character other than \'g\', \'i\', or \'m\', or if it contains the same one more than once, then throw a SyntaxError exception")]
        [TestCase("S15.10.4.1_A5_T4.js", Description = "If F contains any character other than \'g\', \'i\', or \'m\', or if it contains the same one more than once, then throw a SyntaxError exception")]
        [TestCase("S15.10.4.1_A5_T5.js", Description = "If F contains any character other than \'g\', \'i\', or \'m\', or if it contains the same one more than once, then throw a SyntaxError exception")]
        [TestCase("S15.10.4.1_A5_T6.js", Description = "If F contains any character other than \'g\', \'i\', or \'m\', or if it contains the same one more than once, then throw a SyntaxError exception")]
        [TestCase("S15.10.4.1_A5_T7.js", Description = "If F contains any character other than \'g\', \'i\', or \'m\', or if it contains the same one more than once, then throw a SyntaxError exception")]
        [TestCase("S15.10.4.1_A5_T8.js", Description = "If F contains any character other than \'g\', \'i\', or \'m\', or if it contains the same one more than once, then throw a SyntaxError exception")]
        [TestCase("S15.10.4.1_A5_T9.js", Description = "If F contains any character other than \'g\', \'i\', or \'m\', or if it contains the same one more than once, then throw a SyntaxError exception")]
        public void IfFContainsAnyCharacterOtherThanGIOrMOrIfItContainsTheSameOneMoreThanOnceThenThrowASyntaxErrorException(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.10.4.1")]
        [TestCase("S15.10.4.1_A6_T1.js", Description = "The [[Class]] property of the newly constructed object is set to \"RegExp\"")]
        public void TheClassPropertyOfTheNewlyConstructedObjectIsSetToRegExp(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.10.4.1")]
        [TestCase("S15.10.4.1_A7_T1.js", Description = "The [[Prototype]] property of the newly constructed object is set to the original RegExp prototype object, the one that is the initial value of RegExp.prototype")]
        [TestCase("S15.10.4.1_A7_T2.js", Description = "The [[Prototype]] property of the newly constructed object is set to the original RegExp prototype object, the one that is the initial value of RegExp.prototype")]
        public void ThePrototypePropertyOfTheNewlyConstructedObjectIsSetToTheOriginalRegExpPrototypeObjectTheOneThatIsTheInitialValueOfRegExpPrototype(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.10.4.1")]
        [TestCase("S15.10.4.1_A8_T1.js", Description = "let P be ToString(pattern) and let F be ToString(flags)")]
        [TestCase("S15.10.4.1_A8_T10.js", Description = "let P be ToString(pattern) and let F be ToString(flags)")]
        [TestCase("S15.10.4.1_A8_T11.js", Description = "let P be ToString(pattern) and let F be ToString(flags)")]
        [TestCase("S15.10.4.1_A8_T12.js", Description = "let P be ToString(pattern) and let F be ToString(flags)")]
        [TestCase("S15.10.4.1_A8_T13.js", Description = "let P be ToString(pattern) and let F be ToString(flags)")]
        [TestCase("S15.10.4.1_A8_T2.js", Description = "let P be ToString(pattern) and let F be ToString(flags)")]
        [TestCase("S15.10.4.1_A8_T3.js", Description = "let P be ToString(pattern) and let F be ToString(flags)")]
        [TestCase("S15.10.4.1_A8_T4.js", Description = "let P be ToString(pattern) and let F be ToString(flags)")]
        [TestCase("S15.10.4.1_A8_T5.js", Description = "let P be ToString(pattern) and let F be ToString(flags)")]
        [TestCase("S15.10.4.1_A8_T6.js", Description = "let P be ToString(pattern) and let F be ToString(flags)")]
        [TestCase("S15.10.4.1_A8_T7.js", Description = "let P be ToString(pattern) and let F be ToString(flags)")]
        [TestCase("S15.10.4.1_A8_T8.js", Description = "let P be ToString(pattern) and let F be ToString(flags)")]
        [TestCase("S15.10.4.1_A8_T9.js", Description = "let P be ToString(pattern) and let F be ToString(flags)")]
        public void LetPBeToStringPatternAndLetFBeToStringFlags(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.10.4.1")]
        [TestCase("S15.10.4.1_A9_T1.js", Description = "If P\'s characters do not have the form Pattern, then throw a SyntaxError exception")]
        [TestCase("S15.10.4.1_A9_T2.js", Description = "If P\'s characters do not have the form Pattern, then throw a SyntaxError exception")]
        [TestCase("S15.10.4.1_A9_T3.js", Description = "If P\'s characters do not have the form Pattern, then throw a SyntaxError exception")]
        public void IfPSCharactersDoNotHaveTheFormPatternThenThrowASyntaxErrorException(string file)
        {
            RunFile(file);
        }
    }
}