// <auto-generated />
namespace IronJS.Tests.UnitTests.Sputnik.Conformance.NativeECMAScriptObjects.StringObjects
{
    using System;
    using NUnit.Framework;

    [TestFixture]
    public class PropertiesOfStringInstancesTests : SputnikTestFixture
    {
        public PropertiesOfStringInstancesTests()
            : base(@"Conformance\15_Native_ECMA_Script_Objects\15.5_String_Objects\15.5.5_Properties_of_String_Instances")
        {
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.5.1")]
        [TestCase("S15.5.5.1_A1.js", Description = "length property contains the number of characters in the String value represented by this String object")]
        public void LengthPropertyContainsTheNumberOfCharactersInTheStringValueRepresentedByThisStringObject(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.5.1")]
        [TestCase("S15.5.5.1_A2.js", Description = "length property has the attributes {DontEnum}")]
        public void LengthPropertyHasTheAttributesDontEnum(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.5.1")]
        [TestCase("S15.5.5.1_A3.js", Description = "length property has the attributes {DontDelete}")]
        public void LengthPropertyHasTheAttributesDontDelete(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.5.1")]
        [TestCase("S15.5.5.1_A4.js", Description = "length property has the attributes {ReadOnly}")]
        public void LengthPropertyHasTheAttributesReadOnly(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.5.1")]
        [TestCase("S15.5.5.1_A5.js", Description = "Once a String object is created, the length property is unchanging")]
        public void OnceAStringObjectIsCreatedTheLengthPropertyIsUnchanging(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.5")]
        [TestCase("S15.5.5_A1_T1.js", Description = "String instance has not [[call]] property")]
        [TestCase("S15.5.5_A1_T2.js", Description = "String instance has not [[call]] property")]
        public void StringInstanceHasNotCallProperty(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.5")]
        [TestCase("S15.5.5_A2_T1.js", Description = "String instance has not [[construct]] property")]
        [TestCase("S15.5.5_A2_T2.js", Description = "String instance has not [[construct]] property")]
        public void StringInstanceHasNotConstructProperty(string file)
        {
            RunFile(file);
        }
    }
}