// <auto-generated />
namespace IronJS.Tests.UnitTests.Sputnik.Conformance.NativeECMAScriptObjects.StringObjects.PropertiesOfTheStringPrototypeObject
{
    using System;
    using NUnit.Framework;

    [TestFixture]
    public class StringPrototypeLastIndexOfTests : SputnikTestFixture
    {
        public StringPrototypeLastIndexOfTests()
            : base(@"Conformance\15_Native_ECMA_Script_Objects\15.5_String_Objects\15.5.4_Properties_of_the_String_Prototype_Object\15.5.4.8_String.prototype.lastIndexOf")
        {
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.8")]
        [TestCase("S15.5.4.8_A1_T1.js", Description = "String.prototype.lastIndexOf(searchString, position)")]
        [TestCase("S15.5.4.8_A1_T10.js", Description = "String.prototype.lastIndexOf(searchString, position)")]
        [TestCase("S15.5.4.8_A1_T11.js", Ignore = true, IgnoreReason = "This test is incorrect.  Consult ECMA-262, Section 15.9.5.2.", Description = "String.prototype.lastIndexOf(searchString, position)")]
        [TestCase("S15.5.4.8_A1_T12.js", Description = "String.prototype.lastIndexOf(searchString, position)")]
        [TestCase("S15.5.4.8_A1_T2.js", Description = "String.prototype.lastIndexOf(searchString, position)")]
        [TestCase("S15.5.4.8_A1_T3.js", Description = "String.prototype.lastIndexOf(searchString, position)")]
        [TestCase("S15.5.4.8_A1_T4.js", Description = "String.prototype.lastIndexOf(searchString, position)")]
        [TestCase("S15.5.4.8_A1_T5.js", Description = "String.prototype.lastIndexOf(searchString, position)")]
        [TestCase("S15.5.4.8_A1_T6.js", Description = "String.prototype.lastIndexOf(searchString, position)")]
        [TestCase("S15.5.4.8_A1_T7.js", Description = "String.prototype.lastIndexOf(searchString, position)")]
        [TestCase("S15.5.4.8_A1_T8.js", Description = "String.prototype.lastIndexOf(searchString, position)")]
        [TestCase("S15.5.4.8_A1_T9.js", Description = "String.prototype.lastIndexOf(searchString, position)")]
        public void StringPrototypeLastIndexOfSearchStringPosition(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.8")]
        [TestCase("S15.5.4.8_A10.js", Description = "The String.prototype.lastIndexOf.length property has the attribute ReadOnly")]
        public void TheStringPrototypeLastIndexOfLengthPropertyHasTheAttributeReadOnly(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.8")]
        [TestCase("S15.5.4.8_A11.js", Description = "The length property of the lastIndexOf method is 1")]
        public void TheLengthPropertyOfTheLastIndexOfMethodIs1(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.8")]
        [TestCase("S15.5.4.8_A4_T1.js", Description = "when String.prototype.lastIndexOf(searchString, position) is called first Call ToString, giving it the this value as its argument. Then Call ToString(searchString) and Call ToNumber(position)")]
        [TestCase("S15.5.4.8_A4_T2.js", Description = "when String.prototype.lastIndexOf(searchString, position) is called first Call ToString, giving it the this value as its argument. Then Call ToString(searchString) and Call ToNumber(position)")]
        [TestCase("S15.5.4.8_A4_T3.js", Description = "when String.prototype.lastIndexOf(searchString, position) is called first Call ToString, giving it the this value as its argument. Then Call ToString(searchString) and Call ToNumber(position)")]
        [TestCase("S15.5.4.8_A4_T4.js", Description = "when String.prototype.lastIndexOf(searchString, position) is called first Call ToString, giving it the this value as its argument. Then Call ToString(searchString) and Call ToNumber(position)")]
        [TestCase("S15.5.4.8_A4_T5.js", Description = "when String.prototype.lastIndexOf(searchString, position) is called first Call ToString, giving it the this value as its argument. Then Call ToString(searchString) and Call ToNumber(position)")]
        public void WhenStringPrototypeLastIndexOfSearchStringPositionIsCalledFirstCallToStringGivingItTheThisValueAsItsArgumentThenCallToStringSearchStringAndCallToNumberPosition(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 13.2")]
        [Category("ECMA 15.5.4.8")]
        [TestCase("S15.5.4.8_A6.js", Description = "String.prototype.lastIndexOf has not prototype property")]
        public void StringPrototypeLastIndexOfHasNotPrototypeProperty(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 13.2")]
        [Category("ECMA 15.5.4.8")]
        [TestCase("S15.5.4.8_A7.js", Description = "String.prototype.lastIndexOf can\'t be used as constructor")]
        public void StringPrototypeLastIndexOfCanTBeUsedAsConstructor(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.8")]
        [TestCase("S15.5.4.8_A8.js", Description = "The String.prototype.lastIndexOf.length property has the attribute DontEnum")]
        public void TheStringPrototypeLastIndexOfLengthPropertyHasTheAttributeDontEnum(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.8")]
        [TestCase("S15.5.4.8_A9.js", Description = "The String.prototype.lastIndexOf.length property has the attribute DontDelete")]
        public void TheStringPrototypeLastIndexOfLengthPropertyHasTheAttributeDontDelete(string file)
        {
            RunFile(file);
        }
    }
}