// <auto-generated />
namespace IronJS.Tests.UnitTests.Sputnik.Conformance.NativeECMAScriptObjects.StringObjects.PropertiesOfTheStringPrototypeObject
{
    using System;
    using NUnit.Framework;

    [TestFixture]
    public class StringPrototypeMatchTests : SputnikTestFixture
    {
        public StringPrototypeMatchTests()
            : base(@"Conformance\15_Native_ECMA_Script_Objects\15.5_String_Objects\15.5.4_Properties_of_the_String_Prototype_Object\15.5.4.10_String.prototype.match")
        {
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.10")]
        [TestCase("S15.5.4.10_A1_T1.js", Description = "String.prototype.match (regexp)")]
        [TestCase("S15.5.4.10_A1_T10.js", Description = "String.prototype.match (regexp)")]
        [TestCase("S15.5.4.10_A1_T11.js", Description = "String.prototype.match (regexp)")]
        [TestCase("S15.5.4.10_A1_T12.js", Description = "String.prototype.match (regexp)")]
        [TestCase("S15.5.4.10_A1_T13.js", Description = "String.prototype.match (regexp)")]
        [TestCase("S15.5.4.10_A1_T14.js", Description = "String.prototype.match (regexp)")]
        [TestCase("S15.5.4.10_A1_T2.js", Description = "String.prototype.match (regexp)")]
        [TestCase("S15.5.4.10_A1_T3.js", Description = "String.prototype.match (regexp)")]
        [TestCase("S15.5.4.10_A1_T4.js", Description = "String.prototype.match (regexp)")]
        [TestCase("S15.5.4.10_A1_T5.js", Description = "String.prototype.match (regexp)")]
        [TestCase("S15.5.4.10_A1_T6.js", Description = "String.prototype.match (regexp)")]
        [TestCase("S15.5.4.10_A1_T7.js", Description = "String.prototype.match (regexp)")]
        [TestCase("S15.5.4.10_A1_T8.js", Description = "String.prototype.match (regexp)")]
        [TestCase("S15.5.4.10_A1_T9.js", Description = "String.prototype.match (regexp)")]
        public void StringPrototypeMatchRegexp(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.10")]
        [TestCase("S15.5.4.10_A10.js", Description = "The String.prototype.match.length property has the attribute ReadOnly")]
        public void TheStringPrototypeMatchLengthPropertyHasTheAttributeReadOnly(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.10")]
        [TestCase("S15.5.4.10_A11.js", Description = "The length property of the match method is 1")]
        public void TheLengthPropertyOfTheMatchMethodIs1(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.10.6.2")]
        [Category("ECMA 15.5.4.10")]
        [TestCase("S15.5.4.10_A2_T1.js", Description = "match returns array as specified in 15.10.6.2")]
        [TestCase("S15.5.4.10_A2_T10.js", Description = "match returns array as specified in 15.10.6.2")]
        [TestCase("S15.5.4.10_A2_T11.js", Description = "match returns array as specified in 15.10.6.2")]
        [TestCase("S15.5.4.10_A2_T12.js", Description = "match returns array as specified in 15.10.6.2")]
        [TestCase("S15.5.4.10_A2_T13.js", Description = "match returns array as specified in 15.10.6.2")]
        [TestCase("S15.5.4.10_A2_T14.js", Description = "match returns array as specified in 15.10.6.2")]
        [TestCase("S15.5.4.10_A2_T15.js", Description = "match returns array as specified in 15.10.6.2")]
        [TestCase("S15.5.4.10_A2_T16.js", Description = "match returns array as specified in 15.10.6.2")]
        [TestCase("S15.5.4.10_A2_T17.js", Description = "match returns array as specified in 15.10.6.2")]
        [TestCase("S15.5.4.10_A2_T18.js", Description = "match returns array as specified in 15.10.6.2")]
        [TestCase("S15.5.4.10_A2_T2.js", Description = "match returns array as specified in 15.10.6.2")]
        [TestCase("S15.5.4.10_A2_T3.js", Description = "match returns array as specified in 15.10.6.2")]
        [TestCase("S15.5.4.10_A2_T4.js", Description = "match returns array as specified in 15.10.6.2")]
        [TestCase("S15.5.4.10_A2_T5.js", Description = "match returns array as specified in 15.10.6.2")]
        [TestCase("S15.5.4.10_A2_T6.js", Description = "match returns array as specified in 15.10.6.2")]
        [TestCase("S15.5.4.10_A2_T7.js", Description = "match returns array as specified in 15.10.6.2")]
        [TestCase("S15.5.4.10_A2_T8.js", Description = "match returns array as specified in 15.10.6.2")]
        [TestCase("S15.5.4.10_A2_T9.js", Description = "match returns array as specified in 15.10.6.2")]
        public void MatchReturnsArrayAsSpecifiedIn151062(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 13.2")]
        [Category("ECMA 15.5.4.10")]
        [TestCase("S15.5.4.10_A6.js", Description = "String.prototype.match has not prototype property")]
        public void StringPrototypeMatchHasNotPrototypeProperty(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 13.2")]
        [Category("ECMA 15.5.4.10")]
        [TestCase("S15.5.4.10_A7.js", Description = "String.prototype.match can\'t be used as constructor")]
        public void StringPrototypeMatchCanTBeUsedAsConstructor(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.10")]
        [TestCase("S15.5.4.10_A8.js", Description = "The String.prototype.match.length property has the attribute DontEnum")]
        public void TheStringPrototypeMatchLengthPropertyHasTheAttributeDontEnum(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.10")]
        [TestCase("S15.5.4.10_A9.js", Description = "The String.prototype.match.length property has the attribute DontDelete")]
        public void TheStringPrototypeMatchLengthPropertyHasTheAttributeDontDelete(string file)
        {
            RunFile(file);
        }
    }
}