// <auto-generated />
namespace IronJS.Tests.UnitTests.Sputnik.Conformance.NativeECMAScriptObjects.StringObjects.PropertiesOfTheStringPrototypeObject
{
    using System;
    using NUnit.Framework;

    [TestFixture]
    public class StringPrototypeSearchTests : SputnikTestFixture
    {
        public StringPrototypeSearchTests()
            : base(@"Conformance\15_Native_ECMA_Script_Objects\15.5_String_Objects\15.5.4_Properties_of_the_String_Prototype_Object\15.5.4.12_String.prototype.search")
        {
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.12")]
        [TestCase("S15.5.4.12_A1.1_T1.js", Description = "String.prototype.search (regexp) without arguments behaves like with argument \"undefined\"")]
        public void StringPrototypeSearchRegexpWithoutArgumentsBehavesLikeWithArgumentUndefined(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.12")]
        [TestCase("S15.5.4.12_A1_T1.js", Description = "String.prototype.search (regexp)")]
        [TestCase("S15.5.4.12_A1_T10.js", Description = "String.prototype.search (regexp)")]
        [TestCase("S15.5.4.12_A1_T11.js", Description = "String.prototype.search (regexp)")]
        [TestCase("S15.5.4.12_A1_T12.js", Description = "String.prototype.search (regexp)")]
        [TestCase("S15.5.4.12_A1_T13.js", Description = "String.prototype.search (regexp)")]
        [TestCase("S15.5.4.12_A1_T14.js", Description = "String.prototype.search (regexp)")]
        [TestCase("S15.5.4.12_A1_T2.js", Description = "String.prototype.search (regexp)")]
        [TestCase("S15.5.4.12_A1_T3.js", Description = "String.prototype.search (regexp)")]
        [TestCase("S15.5.4.12_A1_T4.js", Description = "String.prototype.search (regexp)")]
        [TestCase("S15.5.4.12_A1_T5.js", Description = "String.prototype.search (regexp)")]
        [TestCase("S15.5.4.12_A1_T6.js", Description = "String.prototype.search (regexp)")]
        [TestCase("S15.5.4.12_A1_T7.js", Description = "String.prototype.search (regexp)")]
        [TestCase("S15.5.4.12_A1_T8.js", Description = "String.prototype.search (regexp)")]
        [TestCase("S15.5.4.12_A1_T9.js", Description = "String.prototype.search (regexp)")]
        public void StringPrototypeSearchRegexp(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.12")]
        [TestCase("S15.5.4.12_A10.js", Description = "The String.prototype.search.length property has the attribute ReadOnly")]
        public void TheStringPrototypeSearchLengthPropertyHasTheAttributeReadOnly(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.12")]
        [TestCase("S15.5.4.12_A11.js", Description = "The length property of the search method is 1")]
        public void TheLengthPropertyOfTheSearchMethodIs1(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.12")]
        [TestCase("S15.5.4.12_A2_T1.js", Description = "String.prototype.search (regexp) returns ...")]
        [TestCase("S15.5.4.12_A2_T2.js", Description = "String.prototype.search (regexp) returns ...")]
        [TestCase("S15.5.4.12_A2_T3.js", Description = "String.prototype.search (regexp) returns ...")]
        [TestCase("S15.5.4.12_A2_T4.js", Description = "String.prototype.search (regexp) returns ...")]
        [TestCase("S15.5.4.12_A2_T5.js", Description = "String.prototype.search (regexp) returns ...")]
        [TestCase("S15.5.4.12_A2_T6.js", Description = "String.prototype.search (regexp) returns ...")]
        [TestCase("S15.5.4.12_A2_T7.js", Description = "String.prototype.search (regexp) returns ...")]
        public void StringPrototypeSearchRegexpReturns(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.12")]
        [TestCase("S15.5.4.12_A3_T1.js", Description = "String.prototype.search (regexp) ignores global properties of regexp")]
        [TestCase("S15.5.4.12_A3_T2.js", Description = "String.prototype.search (regexp) ignores global properties of regexp")]
        public void StringPrototypeSearchRegexpIgnoresGlobalPropertiesOfRegexp(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 13.2")]
        [Category("ECMA 15.5.4.12")]
        [TestCase("S15.5.4.12_A6.js", Description = "String.prototype.search has not prototype property")]
        public void StringPrototypeSearchHasNotPrototypeProperty(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 13.2")]
        [Category("ECMA 15.5.4.12")]
        [TestCase("S15.5.4.12_A7.js", Description = "String.prototype.search can\'t be used as constructor")]
        public void StringPrototypeSearchCanTBeUsedAsConstructor(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.12")]
        [TestCase("S15.5.4.12_A8.js", Description = "The String.prototype.search.length property has the attribute DontEnum")]
        public void TheStringPrototypeSearchLengthPropertyHasTheAttributeDontEnum(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.12")]
        [TestCase("S15.5.4.12_A9.js", Description = "The String.prototype.search.length property has the attribute DontDelete")]
        public void TheStringPrototypeSearchLengthPropertyHasTheAttributeDontDelete(string file)
        {
            RunFile(file);
        }
    }
}