// <auto-generated />
namespace IronJS.Tests.UnitTests.Sputnik.Conformance.NativeECMAScriptObjects.StringObjects.PropertiesOfTheStringPrototypeObject
{
    using System;
    using NUnit.Framework;

    [TestFixture]
    public class StringPrototypeSliceTests : SputnikTestFixture
    {
        public StringPrototypeSliceTests()
            : base(@"Conformance\15_Native_ECMA_Script_Objects\15.5_String_Objects\15.5.4_Properties_of_the_String_Prototype_Object\15.5.4.13_String.prototype.slice")
        {
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.13")]
        [TestCase("S15.5.4.13_A1_T1.js", Description = "String.prototype.slice (start, end)")]
        [TestCase("S15.5.4.13_A1_T10.js", Description = "String.prototype.slice (start, end)")]
        [TestCase("S15.5.4.13_A1_T11.js", Description = "String.prototype.slice (start, end)")]
        [TestCase("S15.5.4.13_A1_T12.js", Description = "String.prototype.slice (start, end)")]
        [TestCase("S15.5.4.13_A1_T13.js", Description = "String.prototype.slice (start, end)")]
        [TestCase("S15.5.4.13_A1_T14.js", Description = "String.prototype.slice (start, end)")]
        [TestCase("S15.5.4.13_A1_T15.js", Description = "String.prototype.slice (start, end)")]
        [TestCase("S15.5.4.13_A1_T2.js", Description = "String.prototype.slice (start, end)")]
        [TestCase("S15.5.4.13_A1_T3.js", Description = "String.prototype.slice (start, end)")]
        [TestCase("S15.5.4.13_A1_T4.js", Description = "String.prototype.slice (start, end)")]
        [TestCase("S15.5.4.13_A1_T5.js", Description = "String.prototype.slice (start, end)")]
        [TestCase("S15.5.4.13_A1_T6.js", Description = "String.prototype.slice (start, end)")]
        [TestCase("S15.5.4.13_A1_T7.js", Description = "String.prototype.slice (start, end)")]
        [TestCase("S15.5.4.13_A1_T8.js", Description = "String.prototype.slice (start, end)")]
        [TestCase("S15.5.4.13_A1_T9.js", Description = "String.prototype.slice (start, end)")]
        public void StringPrototypeSliceStartEnd(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.13")]
        [TestCase("S15.5.4.13_A10.js", Description = "The String.prototype.slice.length property has the attribute ReadOnly")]
        public void TheStringPrototypeSliceLengthPropertyHasTheAttributeReadOnly(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.13")]
        [TestCase("S15.5.4.13_A11.js", Description = "The length property of the slice method is 2")]
        public void TheLengthPropertyOfTheSliceMethodIs2(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.13")]
        [TestCase("S15.5.4.13_A2_T1.js", Description = "String.prototype.slice (start, end) returns a string value(not object)")]
        [TestCase("S15.5.4.13_A2_T2.js", Description = "String.prototype.slice (start, end) returns a string value(not object)")]
        [TestCase("S15.5.4.13_A2_T3.js", Description = "String.prototype.slice (start, end) returns a string value(not object)")]
        [TestCase("S15.5.4.13_A2_T4.js", Description = "String.prototype.slice (start, end) returns a string value(not object)")]
        [TestCase("S15.5.4.13_A2_T5.js", Description = "String.prototype.slice (start, end) returns a string value(not object)")]
        [TestCase("S15.5.4.13_A2_T6.js", Description = "String.prototype.slice (start, end) returns a string value(not object)")]
        [TestCase("S15.5.4.13_A2_T7.js", Description = "String.prototype.slice (start, end) returns a string value(not object)")]
        [TestCase("S15.5.4.13_A2_T8.js", Description = "String.prototype.slice (start, end) returns a string value(not object)")]
        [TestCase("S15.5.4.13_A2_T9.js", Description = "String.prototype.slice (start, end) returns a string value(not object)")]
        public void StringPrototypeSliceStartEndReturnsAStringValueNotObject(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.13")]
        [TestCase("S15.5.4.13_A3_T1.js", Description = "String.prototype.slice (start, end) can be applied to object instances")]
        [TestCase("S15.5.4.13_A3_T2.js", Description = "String.prototype.slice (start, end) can be applied to object instances")]
        [TestCase("S15.5.4.13_A3_T3.js", Description = "String.prototype.slice (start, end) can be applied to object instances")]
        [TestCase("S15.5.4.13_A3_T4.js", Description = "String.prototype.slice (start, end) can be applied to object instances")]
        public void StringPrototypeSliceStartEndCanBeAppliedToObjectInstances(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 13.2")]
        [Category("ECMA 15.5.4.13")]
        [TestCase("S15.5.4.13_A6.js", Description = "String.prototype.slice has not prototype property")]
        public void StringPrototypeSliceHasNotPrototypeProperty(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 13.2")]
        [Category("ECMA 15.5.4.13")]
        [TestCase("S15.5.4.13_A7.js", Description = "String.prototype.slice can\'t be used as constructor")]
        public void StringPrototypeSliceCanTBeUsedAsConstructor(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.13")]
        [TestCase("S15.5.4.13_A8.js", Description = "The String.prototype.slice.length property has the attribute DontEnum")]
        public void TheStringPrototypeSliceLengthPropertyHasTheAttributeDontEnum(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.5.4.13")]
        [TestCase("S15.5.4.13_A9.js", Description = "The String.prototype.slice.length property has the attribute DontDelete")]
        public void TheStringPrototypeSliceLengthPropertyHasTheAttributeDontDelete(string file)
        {
            RunFile(file);
        }
    }
}