// <auto-generated />
namespace IronJS.Tests.UnitTests.Sputnik.Conformance.NativeECMAScriptObjects.TheGlobalObject.FunctionPropertiesOfTheGlobalObject
{
    using System;
    using NUnit.Framework;

    [TestFixture]
    public class IsFiniteTests : SputnikTestFixture
    {
        public IsFiniteTests()
            : base(@"Conformance\15_Native_ECMA_Script_Objects\15.1_The_Global_Object\15.1.2_Function_Properties_of_the_Global_Object\15.1.2.5_isFinite")
        {
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.1.2.5")]
        [TestCase("S15.1.2.5_A1_T1.js", Description = "isFinite applies ToNumber to its argument, then return false if the result is NaN, +Infinity, -Infinity, and otherwise return true")]
        [TestCase("S15.1.2.5_A1_T2.js", Description = "isFinite applies ToNumber to its argument, then return false if the result is NaN, +Infinity, -Infinity, and otherwise return true")]
        public void IsFiniteAppliesToNumberToItsArgumentThenReturnFalseIfTheResultIsNaNInfinityInfinityAndOtherwiseReturnTrue(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 12.6.4")]
        [Category("ECMA 15.1.2.5")]
        [Category("ECMA 15.2.4.7")]
        [TestCase("S15.1.2.5_A2.1.js", Description = "The length property of isFinite has the attribute DontEnum")]
        public void TheLengthPropertyOfIsFiniteHasTheAttributeDontEnum(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.4.1")]
        [Category("ECMA 15.1.2.5")]
        [Category("ECMA 15.2.4.5")]
        [TestCase("S15.1.2.5_A2.2.js", Description = "The length property of isFinite has the attribute DontDelete")]
        public void TheLengthPropertyOfIsFiniteHasTheAttributeDontDelete(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.1.2.5")]
        [TestCase("S15.1.2.5_A2.3.js", Description = "The length property of isFinite has the attribute ReadOnly")]
        public void TheLengthPropertyOfIsFiniteHasTheAttributeReadOnly(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.1.2.5")]
        [TestCase("S15.1.2.5_A2.4.js", Description = "The length property of isFinite is 1")]
        public void TheLengthPropertyOfIsFiniteIs1(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 12.6.4")]
        [Category("ECMA 15.1.2.5")]
        [Category("ECMA 15.2.4.7")]
        [TestCase("S15.1.2.5_A2.5.js", Description = "The isFinite property has the attribute DontEnum")]
        public void TheIsFinitePropertyHasTheAttributeDontEnum(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.1.2.5")]
        [TestCase("S15.1.2.5_A2.6.js", Description = "The isFinite property has not prototype property")]
        public void TheIsFinitePropertyHasNotPrototypeProperty(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.2.2")]
        [Category("ECMA 15.1.2.5")]
        [TestCase("S15.1.2.5_A2.7.js", Description = "The isFinite property can\'t be used as constructor")]
        public void TheIsFinitePropertyCanTBeUsedAsConstructor(string file)
        {
            RunFile(file);
        }
    }
}