// <auto-generated />
namespace IronJS.Tests.UnitTests.Sputnik.Conformance.TypeConversion
{
    using System;
    using NUnit.Framework;

    [TestFixture]
    public class ToBooleanTests : SputnikTestFixture
    {
        public ToBooleanTests()
            : base(@"Conformance\09_Type_Conversion\9.2_ToBoolean")
        {
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.4.9")]
        [Category("ECMA 15.6.1")]
        [Category("ECMA 9.2")]
        [TestCase("S9.2_A1_T1.js", Description = "Result of boolean conversion from undefined value is false")]
        [TestCase("S9.2_A1_T2.js", Description = "Result of boolean conversion from undefined value is false")]
        public void ResultOfBooleanConversionFromUndefinedValueIsFalse(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.4.9")]
        [Category("ECMA 15.6.1")]
        [Category("ECMA 9.2")]
        [TestCase("S9.2_A2_T1.js", Description = "Result of boolean conversion from null value is false")]
        [TestCase("S9.2_A2_T2.js", Description = "Result of boolean conversion from null value is false")]
        public void ResultOfBooleanConversionFromNullValueIsFalse(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.4.9")]
        [Category("ECMA 15.6.1")]
        [Category("ECMA 9.2")]
        [TestCase("S9.2_A3_T1.js", Description = "Result of boolean conversion from boolean value is no conversion")]
        [TestCase("S9.2_A3_T2.js", Description = "Result of boolean conversion from boolean value is no conversion")]
        public void ResultOfBooleanConversionFromBooleanValueIsNoConversion(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.4.9")]
        [Category("ECMA 15.6.1")]
        [Category("ECMA 9.2")]
        [TestCase("S9.2_A4_T1.js", Description = "Result of boolean conversion from number value is false if the argument is +0, -0, or NaN")]
        [TestCase("S9.2_A4_T2.js", Description = "Result of boolean conversion from number value is false if the argument is +0, -0, or NaN")]
        [TestCase("S9.2_A4_T3.js", Description = "Result of boolean conversion from number value is false if the argument is +0, -0, or NaN")]
        [TestCase("S9.2_A4_T4.js", Description = "Result of boolean conversion from number value is false if the argument is +0, -0, or NaN")]
        public void ResultOfBooleanConversionFromNumberValueIsFalseIfTheArgumentIs00OrNaN(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.4.9")]
        [Category("ECMA 15.6.1")]
        [Category("ECMA 9.2")]
        [TestCase("S9.2_A5_T1.js", Description = "Result of boolean conversion from nonempty string value (length is not zero) is true")]
        [TestCase("S9.2_A5_T2.js", Description = "Result of boolean conversion from nonempty string value (length is not zero) is true")]
        [TestCase("S9.2_A5_T3.js", Description = "Result of boolean conversion from nonempty string value (length is not zero) is true")]
        [TestCase("S9.2_A5_T4.js", Description = "Result of boolean conversion from nonempty string value (length is not zero) is true")]
        public void ResultOfBooleanConversionFromNonemptyStringValueLengthIsNotZeroIsTrue(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.4.9")]
        [Category("ECMA 15.6.1")]
        [Category("ECMA 9.2")]
        [TestCase("S9.2_A6_T1.js", Description = "Result of boolean conversion from object is true")]
        [TestCase("S9.2_A6_T2.js", Description = "Result of boolean conversion from object is true")]
        public void ResultOfBooleanConversionFromObjectIsTrue(string file)
        {
            RunFile(file);
        }
    }
}