// <auto-generated />
namespace IronJS.Tests.UnitTests.Sputnik.Conformance.TypeConversion
{
    using System;
    using NUnit.Framework;

    [TestFixture]
    public class ToInt32Tests : SputnikTestFixture
    {
        public ToInt32Tests()
            : base(@"Conformance\09_Type_Conversion\9.5_ToInt32")
        {
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.7.1")]
        [Category("ECMA 9.5")]
        [TestCase("S9.5_A1_T1.js", Description = "If value is NaN, +0, -0, +Infinity, or -Infinity, return +0")]
        public void IfValueIsNaN00InfinityOrInfinityReturn0(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.4.8")]
        [Category("ECMA 11.7.1")]
        [Category("ECMA 9.5")]
        [TestCase("S9.5_A2.1_T1.js", Description = "ToInt32 returns values between -2^31 and 2^31-1")]
        [TestCase("S9.5_A2.1_T2.js", Description = "ToInt32 returns values between -2^31 and 2^31-1")]
        public void ToInt32ReturnsValuesBetween231And2311(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.4.8")]
        [Category("ECMA 11.7.1")]
        [Category("ECMA 9.5")]
        [TestCase("S9.5_A2.2_T1.js", Description = "Compute result modulo 2^32")]
        [TestCase("S9.5_A2.2_T2.js", Description = "Compute result modulo 2^32")]
        public void ComputeResultModulo232(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 11.4.8")]
        [Category("ECMA 11.7.1")]
        [Category("ECMA 9.5")]
        [TestCase("S9.5_A2.3_T1.js", Description = "If result is greater than or equal to 2^31, return result -2^32")]
        [TestCase("S9.5_A2.3_T2.js", Description = "If result is greater than or equal to 2^31, return result -2^32")]
        public void IfResultIsGreaterThanOrEqualTo231ReturnResult232(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 9.5")]
        [TestCase("S9.5_A3.1_T1.js", Description = "Operator uses ToNumber")]
        [TestCase("S9.5_A3.1_T2.js", Description = "Operator uses ToNumber")]
        [TestCase("S9.5_A3.1_T3.js", Description = "Operator uses ToNumber")]
        [TestCase("S9.5_A3.1_T4.js", Description = "Operator uses ToNumber")]
        public void OperatorUsesToNumber(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 9.5")]
        [TestCase("S9.5_A3.2_T1.js", Description = "Operator uses floor, abs")]
        [TestCase("S9.5_A3.2_T2.js", Description = "Operator uses floor, abs")]
        public void OperatorUsesFloorAbs(string file)
        {
            RunFile(file);
        }
    }
}