// <auto-generated />
namespace IronJS.Tests.UnitTests.Sputnik.Conformance.TypeConversion.ToNumber
{
    using System;
    using NUnit.Framework;

    [TestFixture]
    public class ToNumberFromStringTests : SputnikTestFixture
    {
        public ToNumberFromStringTests()
            : base(@"Conformance\09_Type_Conversion\9.3_ToNumber\9.3.1_ToNumber_from_String")
        {
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A1.js", Description = "The MV of StringNumericLiteral ::: [empty] is 0")]
        public void TheMVOfStringNumericLiteralEmptyIs0(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A10.js", Description = "The MV of StrUnsignedDecimalLiteral:::. DecimalDigits is the MV of DecimalDigits times 10<sup><small>-n</small></sup>, where n is the number of characters in DecimalDigits")]
        public void TheMVOfStrUnsignedDecimalLiteralDecimalDigitsIsTheMVOfDecimalDigitsTimes10SupSmallNSmallSupWhereNIsTheNumberOfCharactersInDecimalDigits(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A11.js", Description = "The MV of StrUnsignedDecimalLiteral:::. DecimalDigits ExponentPart is the MV of DecimalDigits times 10<sup><small>e-n</small></sup>, where n is the number of characters in DecimalDigits and e is the MV of ExponentPart")]
        public void TheMVOfStrUnsignedDecimalLiteralDecimalDigitsExponentPartIsTheMVOfDecimalDigitsTimes10SupSmallENSmallSupWhereNIsTheNumberOfCharactersInDecimalDigitsAndEIsTheMVOfExponentPart(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A12.js", Description = "The MV of StrUnsignedDecimalLiteral::: DecimalDigits ExponentPart is the MV of DecimalDigits times 10<sup><small>e</small></sup>, where e is the MV of ExponentPart")]
        [TestCase("S9.3.1_A8.js", Description = "The MV of StrUnsignedDecimalLiteral::: DecimalDigits. ExponentPart is the MV of DecimalDigits times 10<sup><small>e</small></sup> , where e is the MV of ExponentPart")]
        public void TheMVOfStrUnsignedDecimalLiteralDecimalDigitsExponentPartIsTheMVOfDecimalDigitsTimes10SupSmallESmallSupWhereEIsTheMVOfExponentPart(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A13.js", Description = "The MV of DecimalDigits ::: DecimalDigits DecimalDigit is (the MV of DecimalDigits times 10) plus the MV of DecimalDigit")]
        public void TheMVOfDecimalDigitsDecimalDigitsDecimalDigitIsTheMVOfDecimalDigitsTimes10PlusTheMVOfDecimalDigit(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A14.js", Description = "The MV of SignedInteger ::: + DecimalDigits is the MV of DecimalDigits")]
        public void TheMVOfSignedIntegerDecimalDigitsIsTheMVOfDecimalDigits(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A15.js", Description = "The MV of SignedInteger ::: - DecimalDigits is the negative of the MV of DecimalDigits")]
        public void TheMVOfSignedIntegerDecimalDigitsIsTheNegativeOfTheMVOfDecimalDigits(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A16.js", Description = "The MV of DecimalDigit ::: 0 or of HexDigit ::: 0 is 0")]
        public void TheMVOfDecimalDigit0OrOfHexDigit0Is0(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A17.js", Description = "The MV of DecimalDigit ::: 1 or of HexDigit ::: 1 is 1")]
        public void TheMVOfDecimalDigit1OrOfHexDigit1Is1(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A18.js", Description = "The MV of DecimalDigit ::: 2 or of HexDigit ::: 2 is 2")]
        public void TheMVOfDecimalDigit2OrOfHexDigit2Is2(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A19.js", Description = "The MV of DecimalDigit ::: 3 or of HexDigit ::: 3 is 3")]
        public void TheMVOfDecimalDigit3OrOfHexDigit3Is3(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A2.js", Description = "The MV of StringNumericLiteral ::: StrWhiteSpace is 0")]
        public void TheMVOfStringNumericLiteralStrWhiteSpaceIs0(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A20.js", Description = "The MV of DecimalDigit ::: 4 or of HexDigit ::: 4 is 4")]
        public void TheMVOfDecimalDigit4OrOfHexDigit4Is4(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A21.js", Description = "The MV of DecimalDigit ::: 5 or of HexDigit ::: 5 is 5")]
        public void TheMVOfDecimalDigit5OrOfHexDigit5Is5(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A22.js", Description = "The MV of DecimalDigit ::: 6 or of HexDigit ::: 6 is 6")]
        public void TheMVOfDecimalDigit6OrOfHexDigit6Is6(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A23.js", Description = "The MV of DecimalDigit ::: 7 or of HexDigit ::: 7 is 7")]
        public void TheMVOfDecimalDigit7OrOfHexDigit7Is7(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A24.js", Description = "The MV of DecimalDigit ::: 8 or of HexDigit ::: 8 is 8")]
        public void TheMVOfDecimalDigit8OrOfHexDigit8Is8(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A25.js", Description = "The MV of DecimalDigit ::: 9 or of HexDigit ::: 9 is 9")]
        public void TheMVOfDecimalDigit9OrOfHexDigit9Is9(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A26.js", Description = "The MV of HexDigit ::: a or of HexDigit ::: A is 10")]
        public void TheMVOfHexDigitAOrOfHexDigitAIs10(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A27.js", Description = "The MV of HexDigit ::: b or of HexDigit ::: B is 11")]
        public void TheMVOfHexDigitBOrOfHexDigitBIs11(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A28.js", Description = "The MV of HexDigit ::: c or of HexDigit ::: C is 12")]
        public void TheMVOfHexDigitCOrOfHexDigitCIs12(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A29.js", Description = "The MV of HexDigit ::: d or of HexDigit ::: D is 13")]
        public void TheMVOfHexDigitDOrOfHexDigitDIs13(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A3_T1.js", Description = "The MV of StringNumericLiteral ::: StrWhiteSpaceopt StrNumericLiteral StrWhiteSpaceopt is the MV of StrNumericLiteral, no matter whether white space is present or not")]
        [TestCase("S9.3.1_A3_T2.js", Description = "The MV of StringNumericLiteral ::: StrWhiteSpaceopt StrNumericLiteral StrWhiteSpaceopt is the MV of StrNumericLiteral, no matter whether white space is present or not")]
        public void TheMVOfStringNumericLiteralStrWhiteSpaceoptStrNumericLiteralStrWhiteSpaceoptIsTheMVOfStrNumericLiteralNoMatterWhetherWhiteSpaceIsPresentOrNot(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A30.js", Description = "The MV of HexDigit ::: e or of HexDigit ::: E is 14")]
        public void TheMVOfHexDigitEOrOfHexDigitEIs14(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A31.js", Description = "The MV of HexDigit ::: f or of HexDigit ::: F is 15")]
        public void TheMVOfHexDigitFOrOfHexDigitFIs15(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A32.js", Description = "Once the exact MV for a string numeric literal has been determined, it is then rounded to a value of the Number type with 20 significant digits by replacing each significant digit after the 20th with a 0 digit or the number value")]
        public void OnceTheExactMVForAStringNumericLiteralHasBeenDeterminedItIsThenRoundedToAValueOfTheNumberTypeWith20SignificantDigitsByReplacingEachSignificantDigitAfterThe20thWithA0DigitOrTheNumberValue(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A4_T1.js", Description = "The MV of StrDecimalLiteral::: + StrUnsignedDecimalLiteral is the MV of StrUnsignedDecimalLiteral")]
        [TestCase("S9.3.1_A4_T2.js", Description = "The MV of StrDecimalLiteral::: + StrUnsignedDecimalLiteral is the MV of StrUnsignedDecimalLiteral")]
        public void TheMVOfStrDecimalLiteralStrUnsignedDecimalLiteralIsTheMVOfStrUnsignedDecimalLiteral(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A5_T1.js", Description = "The MV of StrDecimalLiteral::: - StrUnsignedDecimalLiteral is the negative of the MV of StrUnsignedDecimalLiteral. (the negative of this 0 is also 0)")]
        [TestCase("S9.3.1_A5_T2.js", Description = "The MV of StrDecimalLiteral::: - StrUnsignedDecimalLiteral is the negative of the MV of StrUnsignedDecimalLiteral. (the negative of this 0 is also 0)")]
        [TestCase("S9.3.1_A5_T3.js", Description = "The MV of StrDecimalLiteral::: - StrUnsignedDecimalLiteral is the negative of the MV of StrUnsignedDecimalLiteral. (the negative of this 0 is also 0)")]
        public void TheMVOfStrDecimalLiteralStrUnsignedDecimalLiteralIsTheNegativeOfTheMVOfStrUnsignedDecimalLiteralTheNegativeOfThis0IsAlso0(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A6_T1.js", Description = "The MV of StrUnsignedDecimalLiteral::: Infinity is 10<sup><small>10000</small></sup> (a value so large that it will round to <b><tt>+&infin")]
        [TestCase("S9.3.1_A6_T2.js", Description = "The MV of StrUnsignedDecimalLiteral::: Infinity is 10<sup><small>10000</small></sup> (a value so large that it will round to <b><tt>+&infin")]
        public void TheMVOfStrUnsignedDecimalLiteralInfinityIs10SupSmall10000SmallSupAValueSoLargeThatItWillRoundToBTtInfin(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A7.js", Description = "The MV of StrUnsignedDecimalLiteral::: DecimalDigits. DecimalDigits is the MV of the first DecimalDigits plus the MV of the second DecimalDigits times 10<sup><small>-n</small></sup>, where n is the number of characters in the second DecimalDigits")]
        public void TheMVOfStrUnsignedDecimalLiteralDecimalDigitsDecimalDigitsIsTheMVOfTheFirstDecimalDigitsPlusTheMVOfTheSecondDecimalDigitsTimes10SupSmallNSmallSupWhereNIsTheNumberOfCharactersInTheSecondDecimalDigits(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 15.7.1")]
        [Category("ECMA 9.3.1")]
        [TestCase("S9.3.1_A9.js", Description = "The MV of StrUnsignedDecimalLiteral::: DecimalDigits. DecimalDigits ExponentPart is (the MV of the first DecimalDigits plus (the MV of the second DecimalDigits times 10<sup><small>-n</small></sup>)) times 10<sup><small>e</small></sup>, where n is the number of characters in the second DecimalDigits and e is the MV of ExponentPart")]
        public void TheMVOfStrUnsignedDecimalLiteralDecimalDigitsDecimalDigitsExponentPartIsTheMVOfTheFirstDecimalDigitsPlusTheMVOfTheSecondDecimalDigitsTimes10SupSmallNSmallSupTimes10SupSmallESmallSupWhereNIsTheNumberOfCharactersInTheSecondDecimalDigitsAndEIsTheMVOfExponentPart(string file)
        {
            RunFile(file);
        }
    }
}