// <auto-generated />
namespace IronJS.Tests.UnitTests.Sputnik.Conformance.TypeConversion.ToString
{
    using System;
    using NUnit.Framework;

    [TestFixture]
    public class ToStringTests : SputnikTestFixture
    {
        public ToStringTests()
            : base(@"Conformance\09_Type_Conversion\9.8_ToString")
        {
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 9.8")]
        [TestCase("S9.8_A1_T1.js", Description = "Result of ToString conversion from undefined value is \"undefined\"")]
        [TestCase("S9.8_A1_T2.js", Description = "Result of ToString conversion from undefined value is \"undefined\"")]
        public void ResultOfToStringConversionFromUndefinedValueIsUndefined(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 9.8")]
        [TestCase("S9.8_A2_T1.js", Description = "Result of ToString conversion from null value is \"null\"")]
        [TestCase("S9.8_A2_T2.js", Description = "Result of ToString conversion from null value is \"null\"")]
        public void ResultOfToStringConversionFromNullValueIsNull(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 9.8")]
        [TestCase("S9.8_A3_T1.js", Description = "Result of ToString conversion from boolean value is \"true\" if the argument is \"true\", else is \"false\"")]
        [TestCase("S9.8_A3_T2.js", Description = "Result of ToString conversion from boolean value is \"true\" if the argument is \"true\", else is \"false\"")]
        public void ResultOfToStringConversionFromBooleanValueIsTrueIfTheArgumentIsTrueElseIsFalse(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 9.8")]
        [TestCase("S9.8_A4_T1.js", Description = "Result of String conversion from string value is the input argument (no conversion)")]
        [TestCase("S9.8_A4_T2.js", Description = "Result of String conversion from string value is the input argument (no conversion)")]
        public void ResultOfStringConversionFromStringValueIsTheInputArgumentNoConversion(string file)
        {
            RunFile(file);
        }

        [Test]
        [Category("Sputnik Conformance")]
        [Category("ECMA 9.8")]
        [TestCase("S9.8_A5_T1.js", Description = "Result of String conversion from Object value is conversion  from primitive value")]
        [TestCase("S9.8_A5_T2.js", Description = "Result of String conversion from Object value is conversion  from primitive value")]
        public void ResultOfStringConversionFromObjectValueIsConversionFromPrimitiveValue(string file)
        {
            RunFile(file);
        }
    }
}